<?php
/**
* Tsuka - Access to the FLV file
* @author Jukka Paasonen
* @see http://paazio.nanbudo.fi/
* 
* @lisense The Q Public License Version 1.0
*          http://www.opensource.org/licenses/qtpl.php
*
* @package Tsuka
* @copyright paazio [at] users.sourceforge.net 2005-2007
*
* This file requires atleast PHP version 4.0.0
*/

require('./initialize.php');

// The download of the video might take some time so prolong the script execution time.
set_time_limit(60*15); // 15 minutes, PHP defaults to 30 seconds

// Write common headers immediately.
header("Cache-Control: no-cache, must-revalidate, post-check=0, pre-check=0");
header("Pragma: no-cache");
header("Expires: 0");

// Check if the user is coming from the right place.
if (!isset($_SESSION['id']) || !isset($_SESSION['level'])) {
	// Get lost!
	exit('Missing stuff');
}

if (isset($_GET['id']) && $_GET['id'] != '') {
	// Atleast the request exists
	if (strlen($_GET['id']) == 32) {
		$id = trim($_GET['id']);
		$filename = $id.'.flv';
		$complete = realpath($cf['flvdir'].$filename);
		if (file_exists($complete)) {
			// Write the starting of the play to the log.
			$timenow = time();
			$size = @filesize($complete);
			$sql = 'INSERT INTO tu_flvplayes (file_id, started, ended, session) VALUES (\''.$id.'\', \''.$timenow.'\', \'0\', \''.$_SESSION['id'].'\')';
			$run = $mdb2->query($sql);
			// Only if insertion of a new row to the DB succeeded, the file is given.
			if (!PEAR::isError($run)) {
				$fdd = @fopen($complete, 'r');
				if ($fdd !== false) {
					// Write the download headers now.
					header("Content-type: video/x-flv");
					header("Content-disposition: inline; filename=".$filename);
					header("Content-Length: ".$size);
					
					// Start sending the file. 4K at a time. This prevents server to exhaust.
					while(!feof($fdd)) {
						$buffer = fread($fdd, 4096);
						print $buffer;
					}
					fclose($fdd);

					// Since we came to this row, we can assume that the download is completed.
					// Update the log.
					$sql = 'UPDATE tu_flvplayes SET ended=\''.time().'\' WHERE started=\''.$timenow.'\' AND session=\''.$_SESSION['id'].'\' AND file_id=\''.$id.'\' LIMIT 1';
					$run = $mdb2->query($sql);
				}
				else {
					// File could not be opened for reading.
					exit('File could not be opened.');
				}	
			}
			else {
				// A new row could not be inserted.
				exit('Difficulties with the baby milk.');
			}
			// Close the connection to the database
			$mdb2->disconnect();
		}
		else {
			// File not found.
			exit('File not found');
		}
	}
	else {
		exit('ID not usable');
	}
}
else {
	// File is not available anymore or not yet.
	exit('File not available');
}
?>