<?php
/**
* Tsuka - CSS file creator
* @author Jukka Paasonen
* @see http://paazio.nanbudo.fi/
* 
* @lisense The Q Public License Version 1.0
*          http://www.opensource.org/licenses/qtpl.php
*
* @package Tsuka
* @copyright paazio [at] users.sourceforge.net 2005-2007
*
* This file requires atleast PHP version 4.3.2
*/
require('./initialize.php');
header('Content-type: text/html; charset=UTF-8');
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" 
	"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en-US" lang="en-US">
<head>
	<title>Tsuka v1.0 - CSS creator</title>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
	<meta name="title" content="Tsuka - Flash video archiving" />
	<meta name="author" content="Jukka Paasonen" />
	<link rel="stylesheet" type="text/css" href="css/tsuka_v1.css" />
	<link rel="stylesheet" type="text/css" href="css/csscreator.css" />
	<link rel="shortcut icon" type="image/x-icon" href="favicon.ico" />
	<script type="text/javascript" src="js/csscreator.js"></script>
</head>
<body>
<table class="headarea">
	<tr>
		<td width="120" rowspan="2">
			<img src="img/tsuka_logo.png" id="logo1" alt="Tsuka - Flash video archiving" width="98" height="98" />
		</td>
		<td id="headtext">
			Tsuka - Flash video archiving
		</td>
	</tr>
	<tr>
		<td id="menubar">
			<a href="#" onClick="writecss();">Save CSS</a>
		</td>
	</tr>
</table>
<table id="outlines">
	<tr>
		<td id="out_up_left"></td>
		<td id="out_up_center"></td>
		<td id="out_up_right"></td>
	</tr>
	<tr>
		<td id="out_mid_left"></td>
		<td id="out_mid_center">
			<form name="f1">
				<table width="97%">
					<tr>
						<td class="setti">
							<b>Body</b>
							<br />Font-size: 
							<select name="body_fsize" onChange="document.body.style.fontSize=this.value">
								<script type="text/javascript">
								// Pixel size of texts.
								for (var i = 6; i < 23; i++) {
									document.write('<option value="' + i + 'px">' + i + ' px</option>');
								}
								</script>
							</select>
							<br />Font-family:
							<select name="body_ffamily" onChange="document.body.style.fontFamily=this.value">
								<script type="text/javascript">
								// Pixel size of texts.
								for (var thisone in fontlist) {
									document.write('<option value="' + fontlist[thisone] + '">' + fontlist[thisone] + '</option>');
								}
								</script>
							</select>
							<br />Background-color: 
							<input type="text" name="body_bg" onChange="document.body.style.backgroundColor=this.value" />
							</td><td width="315" class="setti" rowspan="2">
							<b>Img</b><br />
							Border: 
							<select name="img_bsize" onChange="document.getElementById('image1').style.borderWidth=this.value">
								<script type="text/javascript">
								// Pixel size of texts.
								for (var i = 1; i < 11; i++) {
									document.write('<option value="' + i + 'px">' + i + ' px</option>');
								}
								</script>
							</select>
							<select name="img_btype" onChange="document.getElementById('image1').style.borderStyle=this.value">
								<script type="text/javascript">
								// Pixel size of texts.
								for (var thisone in bordertypes) {
									document.write('<option value="' + bordertypes[thisone] + '">' + bordertypes[thisone] + '</option>');
								}
								</script>
							</select>
							<select name="img_bcolor" onChange="document.getElementById('image1').style.borderColor=this.value">
								<script type="text/javascript">
								// Pixel size of texts.
								for (var thisone in colorlist) {
									document.write('<option value="' + colorlist[thisone] + '">' + colorlist[thisone] + '</option>');
								}
								</script>
							</select>
							<br />
							<br />
							<img src="securityofficer.png" alt="Security officer - Keeps the code free" id="image1" />
							<br />
						</td>
					</tr>
					<tr>
						<td class="setti">
							<b>Headarea:</b>
							<br />Font-size: 
							<select name="head_fsize" onChange="document.getElementById('headtext').style.fontSize=this.value">
								<script type="text/javascript">
								// Pixel size of texts.
								for (var i = 6; i < 23; i++) {
									document.write('<option value="' + i + 'px">' + i + ' px</option>');
								}
								</script>
							</select>
							<br />Font-family:
							<select name="head_ffamily" onChange="document.getElementById('headtext').style.fontFamily=this.value">
								<script type="text/javascript">
								// Pixel size of texts.
								for (var thisone in fontlist) {
									document.write('<option value="' + fontlist[thisone] + '">' + fontlist[thisone] + '</option>');
								}
								</script>
							</select>
							<br />Use logo:
							<input type="checkbox" name="logovisible" checked="checked" onClick="uselogo();" />
						</td>
					</tr>
				</table>
			</form>
		</td>
		<td id="out_mid_right"></td>
	</tr>
	<tr>
		<td id="out_bot_left"></td>
		<td id="out_bot_center"></td>
		<td id="out_bot_right"></td>
	</tr>
	<tr>
		<td colspan="3">
			&nbsp;&copy; 
			Kalle L&ouml;nnroth 
			and 
			<a href="http://paazio.nanbudo.fi/" target="_blank">Jukka Paasonen</a>
			|
			<a href="http://sourceforge.net/project/showfiles.php?group_id=154896" target="_blank">Latest release:
			<?php	
			/** Show the current release with a link to download from sourceforge file list. **/
			echo file_get_contents('./CURRENT_RELEASE').'</a> ';
			if (function_exists('memory_get_usage')) {
				echo '| '.round(memory_get_usage()/1024).' KB';
			}
			?>		
		</td>
	</tr>
</table>

</body>
</html>