/**
* Tsuka - Database creator for MySQL 5
* @author Jukka Paasonen
* @see http://paazio.nanbudo.fi/
* 
* @lisense The Q Public License Version 1.0
*          http://www.opensource.org/licenses/qtpl.php
*
* @package Tsuka
* @copyright paazio [at] users.sourceforge.net 2005-2007
*/

CREATE TABLE tu_content (
  id char(32) collate utf8_swedish_ci NOT NULL,
  view char(6) collate utf8_swedish_ci NOT NULL,
  subject char(160) collate utf8_swedish_ci NOT NULL,
  modified int(10) NOT NULL default '0',
  content text collate utf8_swedish_ci NOT NULL,
  editor varchar(40) collate utf8_swedish_ci NOT NULL,
  lang char(2) collate utf8_swedish_ci NOT NULL default 'en',
  PRIMARY KEY (id)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_swedish_ci;

CREATE TABLE tu_encoder (
  id smallint(4) NOT NULL auto_increment,
  active tinyint(1) NOT NULL default '0',
  ename varchar(100) collate utf8_swedish_ci NOT NULL,
  evalue varchar(200) collate utf8_swedish_ci NOT NULL,
  PRIMARY KEY (id)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_swedish_ci;

CREATE TABLE tu_flvplayes (
  id mediumint(6) NOT NULL,
  file_id char(32) collate utf8_swedish_ci NOT NULL,
  started int(10) NOT NULL default '0',
  ended int(10) NOT NULL default '0',
  session char(32) collate utf8_swedish_ci NOT NULL,
  PRIMARY KEY (id)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_swedish_ci;

CREATE TABLE tu_playlist (
  plid mediumint(6) NOT NULL auto_increment,
  userid varchar(40) collate utf8_swedish_ci NOT NULL,
  created int(10) NOT NULL,
  modified int(10) NOT NULL,
  PRIMARY KEY  (plid)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_swedish_ci;

CREATE TABLE tu_playlist_item (
  plid mediumint(6) NOT NULL,
  videoid char(32) collate utf8_swedish_ci NOT NULL,
  KEY plid (plid)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_swedish_ci;

CREATE TABLE tu_sessions (
  seid char(32) collate utf8_swedish_ci NOT NULL,
  uip char(16) collate utf8_swedish_ci NOT NULL,
  uhost varchar(50) collate utf8_swedish_ci NOT NULL,
  ulang varchar(16) collate utf8_swedish_ci NOT NULL,
  referer varchar(100) collate utf8_swedish_ci NOT NULL,
  flash tinyint(2) NOT NULL default '0',
  browser varchar(100) collate utf8_swedish_ci NOT NULL,
  PRIMARY KEY  (seid)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_swedish_ci;

CREATE TABLE tu_users (
  user_id varchar(40) collate utf8_swedish_ci NOT NULL,
  password varchar(40) collate utf8_swedish_ci NOT NULL,
  level tinyint(1) NOT NULL default '0',
  email varchar(140) collate utf8_swedish_ci NOT NULL,
  realname varchar(100) collate utf8_swedish_ci NOT NULL,
  description text collate utf8_swedish_ci NOT NULL,
  registered int(10) NOT NULL default '0',
  PRIMARY KEY  (user_id)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_swedish_ci;

CREATE TABLE tu_videos (
  video_id varchar(32) collate utf8_swedish_ci NOT NULL,
  subject varchar(100) collate utf8_swedish_ci NOT NULL,
  information text collate utf8_swedish_ci NOT NULL,
  added int(10) NOT NULL default '0',
  user_id varchar(40) collate utf8_swedish_ci NOT NULL,
  PRIMARY KEY  (video_id)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_swedish_ci;

CREATE TABLE tu_visits (
  seid varchar(32) collate utf8_swedish_ci NOT NULL,
  many smallint(3) NOT NULL default '0',
  view varchar(8) collate utf8_swedish_ci NOT NULL,
  lang char(2) collate utf8_swedish_ci NOT NULL,
  dati int(10) NOT NULL default '0',
  KEY seid (seid)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_swedish_ci;
