/**
* Tsuka - Database creator for PostgreSQL 8
* @author Jukka Paasonen
* @see http://paazio.nanbudo.fi/
* 
* @lisense The Q Public License Version 1.0
*          http://www.opensource.org/licenses/qtpl.php
*
* @package Tsuka
* @copyright paazio [at] users.sourceforge.net 2005-2007
*/

CREATE TABLE tu_content (
  con_id CHAR(32) NOT NULL default '',
  view CHAR(6) NOT NULL default '',
  subject CHAR(160) NOT NULL default '',
  modified BIGINT NOT NULL default '0',
  content TEXT NOT NULL,
  editor VARCHAR(40) NOT NULL default '',
  lang CHAR(2) NOT NULL default 'en',
  PRIMARY KEY (con_id)
);

CREATE TABLE tu_flvplayes (
  id MEDIUMINT(6) NOT NULL,
  file_id CHAR(32) NOT NULL default '',
  started BIGINT NOT NULL default '0',
  ended BIGINT NOT NULL default '0',
  session CHAR(32) NOT NULL default '',
  PRIMARY KEY (id)
);

CREATE TABLE tu_playlist (
  plid SERIAL NOT NULL,
  userid VARCHAR(40) NOT NULL,
  created BIGINT NOT NULL,
  modified BIGINT NOT NULL,
  PRIMARY KEY (plid)
);

CREATE TABLE tu_playlist_item (
  id MEDIUMINT(6) NOT NULL,
  plid MEDIUMINT(6) NOT NULL,
  videoid CHAR(32) NOT NULL,
  PRIMARY KEY (id)
);

CREATE TABLE tu_sessions (
  seid CHAR(32) NOT NULL default '',
  uip CHAR(16) NOT NULL default '',
  uhost VARCHAR(50) NOT NULL default '',
  ulang VARCHAR(16) NOT NULL default '',
  referer VARCHAR(100) NOT NULL default '',
  flash SAMLLINT NOT NULL default '0',
  browser VARCHAR(100) NOT NULL default '',
  PRIMARY KEY  (seid)
);

CREATE TABLE tu_encoder (
  encid SERIAL NOT NULL,
  active SMALLINT NOT NULL DEFAULT '0',
  ename VARCHAR(100) NOT NULL DEFAULT '',
  evalue VARCHAR(200) NOT NULL DEFAULT '',
  PRIMARY KEY  (encid)
);

CREATE TABLE tu_users (
  user_id VARCHAR(40) NOT NULL default '',
  password VARCHAR(40) NOT NULL default '',
  level SMALLINT NOT NULL default '0',
  email VARCHAR(140) NOT NULL default '',
  realname VARCHAR(100) NOT NULL default '',
  description TEXT NOT NULL,
  registered BIGINT NOT NULL default '0',
  PRIMARY KEY  (user_id)
);


CREATE TABLE tu_videos (
  video_id VARCHAR(32) NOT NULL default '',
  subject VARCHAR(100) NOT NULL default '',
  information TEXT NOT NULL,
  added BIGINT NOT NULL default '0',
  user_id VARCHAR(40) NOT NULL default '',
  PRIMARY KEY  (video_id)
);


CREATE TABLE tu_visits (
  vid INT(10) NOT NULL ,
  seid VARCHAR(32) NOT NULL default '',
  many SMALLINT(3) NOT NULL default '0',
  view VARCHAR(8) NOT NULL default '',
  lang CHAR(2) NOT NULL default '',
  dati INT(10) NOT NULL default '0',
  PRIMARY KEY (vid)
);
