/**
* Tsuka - Database creator for SQLite 3
* @author Jukka Paasonen
* @see http://paazio.nanbudo.fi/
* 
* @lisense The Q Public License Version 1.0
*          http://www.opensource.org/licenses/qtpl.php
*
* @package Tsuka
* @copyright paazio [at] users.sourceforge.net 2005-2007
*/


CREATE TABLE tu_content (
  id CHAR(32) NOT NULL default '',
  view CHAR(6) NOT NULL default '',
  subject CHAR(160) NOT NULL default '',
  modified INT(10) NOT NULL default '0',
  content TEXT NOT NULL,
  editor VARCHAR(40) NOT NULL default '',
  lang CHAR(2) NOT NULL default 'en',
  PRIMARY KEY (id)
);

CREATE TABLE tu_encoder (
  id SMALLINT(4) NOT NULL,
  active TINYINT(1) NOT NULL DEFAULT '0',
  ename VARCHAR(100) NOT NULL DEFAULT '',
  evalue VARCHAR(200) NOT NULL DEFAULT '',
  PRIMARY KEY (id)
);

CREATE TABLE tu_flvplayes (
  id MEDIUMINT(6) NOT NULL,
  file_id CHAR(32) NOT NULL default '',
  started INT(10) NOT NULL default '0',
  ended INT(10) NOT NULL default '0',
  session CHAR(32) NOT NULL default '',
  PRIMARY KEY (id)
);

CREATE TABLE tu_playlist (
  id MEDIUMINT(6) NOT NULL,
  userid VARCHAR(40) NOT NULL,
  created INT(10) NOT NULL,
  modified INT(10) NOT NULL,
  PRIMARY KEY  (id)
);

CREATE TABLE tu_playlist_item (
  id MEDIUMINT(6) NOT NULL,
  plid MEDIUMINT(6) NOT NULL,
  videoid CHAR(32) NOT NULL,
  PRIMARY KEY (id)
);

CREATE TABLE tu_sessions (
  id CHAR(32) NOT NULL default '',
  uip CHAR(16) NOT NULL default '',
  uhost VARCHAR(50) NOT NULL default '',
  ulang VARCHAR(16) NOT NULL default '',
  referer VARCHAR(100) NOT NULL default '',
  flash TINYINT(2) NOT NULL default '0',
  browser VARCHAR(100) NOT NULL default '',
  PRIMARY KEY (id)
);



CREATE TABLE tu_users (
  id MEDIUMINT(6) NOT NULL,
  username VARCHAR(40) NOT NULL default '',
  password VARCHAR(40) NOT NULL default '',
  level TINYINT(1) NOT NULL default '0',
  email VARCHAR(140) NOT NULL default '',
  realname VARCHAR(100) NOT NULL default '',
  description TEXT NOT NULL,
  registered INT(10) NOT NULL default '0',
  PRIMARY KEY (id)
);


CREATE TABLE tu_videos (
  id VARCHAR(32) NOT NULL default '',
  subject VARCHAR(100) NOT NULL default '',
  information TEXT NOT NULL,
  added INT(10) NOT NULL default '0',
  user_id VARCHAR(40) NOT NULL default '',
  PRIMARY KEY (id)
);


CREATE TABLE tu_visits (
  id INT(10) NOT NULL ,
  seid VARCHAR(32) NOT NULL default '',
  many SMALLINT(3) NOT NULL default '0',
  view VARCHAR(8) NOT NULL default '',
  lang CHAR(2) NOT NULL default '',
  dati INT(10) NOT NULL default '0',
  PRIMARY KEY (id)
);
