<?php
/**
* Tsuka - Feed output of latest videos
* @author Jukka Paasonen
* @see http://paazio.nanbudo.fi/
* 
* @lisense The Q Public License Version 1.0
*          http://www.opensource.org/licenses/qtpl.php
*
* @package Tsuka
* @copyright paazio [at] users.sourceforge.net 2005-2007
*
* This file requires atleast PHP version 3.0.0
*/
require('./initialize.php');

if (!$cf['providefeed']) {
	exit('Sorry, we do not provide feed.');
}

/**
* Which type of feed is in question?
*  - RSS
*    - 0.9
*    - 1.0
*    - 2.0 (default)
* - Atom
*/

if (isset($_GET['ft'])) {
	switch($_GET['ft']) {
		case 'rss09' : $feed = 'rss09'; break;
		case 'rss10' : $feed = 'rss10'; break;
		case 'rss20' : $feed = 'rss20'; break;
		case 'atom'  : $feed = 'atom'; break;
		default : $feed = 'rss20';
	}
}
else {
	$feed = 'rss20';
}


/**
* Feed viewer can choose additionally how many video items to
* view and even choose one user whose latest videos to see.
*
* By default 10 latest are shown as in the front page of Tsuka.
*/

/*
Specifications

	Atom (December 2005)
		<feed xmlns="http://www.w3.org/2005/Atom">
		atomFeed =
		   element atom:feed {
			  atomCommonAttributes,
			  (atomAuthor*
			   & atomCategory*
			   & atomContributor*
			   & atomGenerator?
			   & atomIcon?
			   & atomId
			   & atomLink*
			   & atomLogo?
			   & atomRights?
			   & atomSubtitle?
			   & atomTitle
			   & atomUpdated
			   & extensionElement*),
			  atomEntry*
		   }

		atomEntry =
		   element atom:entry {
			  atomCommonAttributes,
			  (atomAuthor*
			   & atomCategory*
			   & atomContent?
			   & atomContributor*
			   & atomId
			   & atomLink*
			   & atomPublished?
			   & atomRights?
			   & atomSource?
			   & atomSummary?
			   & atomTitle
			   & atomUpdated
			   & extensionElement*)
		   }
*/

$limit = 10;

// Which language to provide?
if (isset($_GET['lang']) && $_GET['lang'] == 'ja') {
	require 'lang_ja.php';
}
else {
	require 'lang_en.php';
}

if ($feed == 'atom') {
	header('Content-type: application/atom+xml; charset=UTF-8');
}
else {
	header('Content-type: text/xml; charset=UTF-8');
}
echo '<?xml version="1.0" encoding="UTF-8" ?>';


// Feed header
switch($feed) {
	case 'rss09' : echo '<rdf:RDF xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#" xmlns="http://my.netscape.com/rdf/simple/0.9/">'; break;
	case 'rss10' : echo '<rdf:RDF xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#" xmlns="http://purl.org/rss/1.0/">'; break;
	case 'rss20' : echo '<rss version="2.0" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">'; break;
	case 'atom'  : echo '<feed xmlns="http://www.w3.org/2005/Atom">'; break;
}

// General feed info
switch($feed) {
	case 'rss09' :
	case 'rss10' :
	case 'rss20' : echo '<channel><title>'.$lg['title'].'</title><link></link><description></description>'; break;
	case 'atom'  : echo ''; break;
}

$sql = 'SELECT * FROM tu_videos ORDER BY added DESC LIMIT '.$limit;
$run = $mdb2->query($sql);
if (!PEAR::isError($run)) {
	while ($res = $run->fetchRow(MDB2_FETCHMODE_ASSOC)) {
		// Do items
		if (substr($feed, 0, 3) == 'rss') {
			echo '<item>';
			echo '<title></title>';
			echo '</item';
		}
		else {
			echo '<entry>';
			echo '<title></title>';
			echo '</entry>';
		}
	}
}
else {
	echo '<!-- '.$run->getMessage().' -->';
}


// Closing tags required
switch($feed) {
	case 'rss09' :
	case 'rss10' : echo '</channel></rdf:RDF>'; break;
	case 'rss20' : echo '</channel></rss>'; break;
	case 'atom'  : echo '</feed>'; break;
}
?>