﻿/*****************************************
Tsuka - Flash video player

Jukka Paasonen
http://paazio.nanbudo.fi/
paazio [at] users.sourceforge.net

The Q Public License Version 1.0
http://www.opensource.org/licenses/qtpl.php

******************************************/

// Which server side script is to be used to transfer the FLV files?
//var transfer:String = "access.php?id=";
var transfer:String = "flvfiles/";

// Get the list of videos to play, XML format it is.
// The regocnition of the owner of the list, is based on session id.
var tsukalist:String = "tsukalist.xml";


#include "tsukaplayer_functions.as"

/*****************************************************************
  A lot of things should be hidden by default.
******************************************************************/
navigate._visible = false;
navigate.buflevel.info._visible = false;
navigate.dropdown.listing._visible = false;
navigate.timeline._xscale = 0;
navigate.volcontrol.voladjust._visible = false;
subjecto._visible = false;
subjecto.upperbg2._visible = false;
videoresize._visible = false;

/*****************************************************************
  A lot of variables should be set false by default.
******************************************************************/
var commanded:Boolean = false;
var defined:Boolean = false;
var dragvolume:Boolean = false;
var pl_loaded:Boolean = false;
var played:Boolean = false;
var resized:Boolean = false;

/*****************************************************************
  Some other defaults are applied.
******************************************************************/
var colors:Object = {outlines:0x666666, fills:0xFFFFFF, bg:0x38B549, txt:0xFF0000, pld:0xFF4455}; // outlines, fills, background, text, played
var curMeta:Object = new Object();
var i:Number = 0;
var subject:Array = new Array();
var title:Array = new Array();
var videoid:Array = new Array();
var vol:Number = 75;
var webcam:Camera;
var resizeinit_y:Number = 0;
var resizeinit_x:Number = 0;
var fileratio:Number = 1;
var videofile:String = "";

/*****************************************************************
  NetStream and NetConnections, global Sound object
******************************************************************/
var connectiva:NetConnection = new NetConnection();
connectiva.connect(null);
var streamer:NetStream = new NetStream(connectiva);
streamer.setBufferTime(2);
// Attach the streamer object to the video presentation object.
videoplace.attachVideo(streamer);

//////////////// Sound object for volume control ///////////////
var soundset:Sound = new Sound();
// Initial volume is 75 (0..100).
soundset.setVolume(vol);


/*****************************************************************
  Parse the XML playlist
******************************************************************/

// XML construtor.
var xmlset:XML = new XML();
// Ignore white space located in the file.
xmlset.ignoreWhite = true;
// OnLoad action for the file loading event.
xmlset.onLoad = function(success:Boolean) {
	// Result of the loading was recorded to the boolean variable "success".
	if (success) {
		// See if the first node has any children.
		if (xmlset.firstChild.hasChildNodes()) {
			//trace("XML has childnodes");
			// Use firstChild to iterate through the child nodes of rootNode
			for (var aNode = xmlset.firstChild.firstChild; aNode != null; aNode = aNode.nextSibling) {
				// Flash supports only nodetypes 1 (ELEMENT_NODE) and 3 (TEXT_NODE).
				//trace("aNode.nodeType : " + aNode.nodeType);
				if (aNode.nodeType == 1) {
					//trace("------------");
					// Add the ID of the video to the video list
					videoid.push(aNode.attributes.id);
					//trace("id : " + aNode.attributes.id);
					// Add the TITLE of the video to the title list
					title.push(aNode.attributes.title);
					//trace("title : " + aNode.attributes.title);
					// Add the SUBJECT of the video to the subject list
					subject.push(aNode.attributes.subject);
					//trace("name : " + aNode.attributes.subject);
				}
			}
		}
		// Create the playlist
		if (subject.length > 1) {
			createPlaylist(subject, navigate.dropdown.listing, colors);
		}
		pl_loaded = true;
		// Run the definer.
		definer();
	}
	else {
		// XML was not loaded nicely.
		trace("XML was not loaded nicely");
	}
	for (var kolli in title) {
		trace ("Kolli " + kolli + " : " + title[kolli]);
	}
};

// Load the xml to the Flash player
if (tsukalist != undefined) {
	xmlset.load(tsukalist);
}
else {
	trace("tsukalist was undefined.");
}


/*****************************************************************
  Button actions which can exist all the time
******************************************************************/

subjecto.tsukalogo.onRelease = function () {
	// Go home or what?
};


/*****************************************************************
  Definer function to define all the actions after the playlist has been loaded.
******************************************************************/


function definer ():Void {
	centerizeTools();
	centerVideo();

	//////////// Initial values and settings ///////////////
	// Name of the first clip
	startNextVideo(i);

	////////// Button actions ///////////////////////
	if (subject.length > 1) {
		navigate.dropdown.selectplay.onPress = function () {
			// Show the playlist if it is not visible
			navigate.dropdown.listing._visible = !navigate.dropdown.listing._visible;
		};
		navigate.dropdown.selectplay.onRollOver = function () {
			// Show the playlist.
			this._parent.listing._visible = true;
		};
	}

	navigate.playpause.onPress = function () {
		// Play or pause playback
		if (played) {
			this.gotoAndStop("pause");
			played = false;
			streamer.pause(false);
		}
		else {
			this.gotoAndStop("play");
			played = true;
			streamer.pause(true);
		}
		trace("played : " + played);
	};



	navigate.timefill.onPress = function () {
		var whereto:Number = ((this._parent._xmouse - this._parent.timebutton._x) / this._parent.timebutton._width) * _root.curMeta.duration;
		// Round to be accurate as 1/100 second
		whereto = Math.round (whereto * 100) / 100;
		this._parent._parent.streamer.seek(whereto);
	};


	/////// Run when a video file is loaded ////////////////

	// Definition for actions has been done.
	_root.defined = true;
}
/////////////// Run all the time /////////////////////
// This is to be run 15 times in every second.
this.onEnterFrame = function () {
	// Wait for the playlist to be loaded.
	if (pl_loaded && defined) {
		// If mouse is placed low, show the navigation panel.
		if (_root._ymouse > (Stage.height - 100)) {
			navigate._visible = true;
		}
		else {
			// Hide only if playlist is not visible
			if (navigate.dropdown.listing._visible == false) {
				navigate._visible = false;
			}
		}
		// Show the subject of the file if mouse is at high location.
		if (_root._ymouse < 100) {
			subjecto._visible = true;
		}
		else {
			subjecto._visible = false;
		}
		// Show the video resize element
		if (_root._ymouse > (Stage.height / 2 - videoresize._height / 2) && _root._ymouse < (Stage.height / 2 + videoresize._height / 2) && _root._xmouse > (Stage.width / 2 - videoresize._width / 2) && _root._xmouse < (Stage.width / 2 + videoresize._width / 2)) {
			videoresize._visible = true;
		}
		else {
			videoresize._visible = false;
		}
		// Resize video element.
		if (_root.resized) {
			resizeVideoManual(videoplace, _root._xmouse - resizeinit_x, _root._ymouse - resizeinit_y);
		}
	}
};

/*****************************************************************
  This area is driven only if the timeline is visible.
  This should reduse the prosessing power required from the user.
******************************************************************/
navigate.onEnterFrame = function () {
	if (this._visible) {
		// Set the correct amount for scaling of the timeline.
		this.timeline._xscale = streamer.bytesLoaded / streamer.bytesTotal * 100;
		// Locate the slider there where the time is.
		// this must take its relations from something which is not scaled.
		this.tslider._x = this.timebutton._x + (streamer.time / curMeta.duration) * this.timebutton._width;
		// Show the current time of total
		this.tslider.timers.times.text = Math.round(streamer.time) + " s";
		if (dragvolume) {
			trace ("Volume dragging is on");
			// Since the volume slider is dragger, do the actual drag effect.
			// When slider is at _y = -57.5, volume is 100,
			// when slider is at _y = -2.5, volume is 0.
			// Totalmovement of volslider is 55 px.
			vol = Math.floor(-1 * (100 / 55) * (this.volcontrol.voladjust.volslider._y + 2));
		}
		// Show the current volume
		this.volcontrol.volvalue.text = vol;
		// Set the current volume
		soundset.setVolume(vol);
		// Check for the buffertime.
		var bufper = Math.min(Math.round(streamer.bufferLength / streamer.bufferTime * 100), 100);
		//trace("Length: " + streamer.bufferLength + "\t" + "Time: " + streamer.bufferTime + "\t" + "Buffer: " + bufferPct + "%");
		// Scale the bar to show the current status.
		this.buflevel.fill._yscale = bufper;
	}
};


stop();