﻿/*****************************************
Tsuka - Flash video player:: Functions and other common stuff

Jukka Paasonen
http://paazio.nanbudo.fi/
paazio [at] users.sourceforge.net

The Q Public License Version 1.0
http://www.opensource.org/licenses/qtpl.php

******************************************/

// Import required components
import flash.geom.ColorTransform;
import flash.geom.Transform;


/*****************************************************************
  Button actions which are available in both versions of the player
******************************************************************/

// Show info of the buffer meter if mouse goes over it.
navigate.buflevel.onRollOver = function () {
	this.info._visible = true;
};
navigate.buflevel.onRollOut = function () {
	this.info._visible = false;
};

navigate.volcontrol.voladjust.volslider.onRelease = volcontrolhide;

navigate.volcontrol.voladjust.volslider.onReleaseOutside = volcontrolhide;

navigate.volcontrol.showslider.onPress = function () {
	// Show volume adjustment bar.
	this._parent.voladjust._visible = true;
	// Dim the area where the volume text is
	this._alpha = 60;
};
navigate.volcontrol.voladjust.volslider.onPress = function () {
	// Move the volume slider in y axis.
	_root.dragvolume = true;
	startDrag(this, false, 0, -57.5, 0, -2.5);
	// When slider is at _y = -57.5, volume is 100,
	// when slider is at _y = -2.5, volume is 0.
};

subjecto.upperbg1.onRollOver = function () {
	this._parent.upperbg2._visible = true;
	this.useCursorHand = false;
};
subjecto.upperbg2.onRollOut = function () {
	this._visible = false;
};
subjecto.tsukalogo.onPress = function () {
	// Go to the project web site
	getURL ("http://tsuka.sf.net/", "_blank");
};
subjecto.tsukalogo.onRollOver = function () {
	this._parent.upperbg2._visible = true;
};

videoresize.onPress = function () {
	// Save initial point
	_root.resizeinit_y = _root._ymouse;
	_root.resizeinit_x = _root._xmouse;
	// Video is now resized.
	_root.resized = true;
};
videoresize.onRelease = function () {
	// Video is now resized.
	_root.resized = false;
};



/*****************************************************************
  Video related stream actions.
******************************************************************/

streamer.onMetaData = function (flvobj:Object) {
	trace ("NetStream.onMetaData called at " + getTimer () + " ms");
	// Trace the data for the programmer to see.
	var infotxt:String = "";
	for (var catman in flvobj) {
		infotxt += catman + ": " + flvobj[catman] + newline;
		trace ("FLV meta : " + catman + " = " + flvobj[catman]);
		_root.curMeta[catman] = flvobj[catman];
	}
	_root.subjecto.upperbg2.videoinfo.text = infotxt;
	_root.subjecto.upperbg2.videoinfo.scroll = true;
	// Keep everything within the player.
	resizeVideoAspect(flvobj.width, flvobj.height);
};

streamer.onStatus = function (flvobj:Object) {
	trace ("NetStream.onStatus called at " + getTimer () + " ms");
	trace ("\t" + flvobj['level'] + ":\t" + flvobj['code']);
	switch (flvobj['code']) {
	case 'NetStream.Play.Start' :
		_root.navigate.playpause.gotoAndStop("pause");
		_root.played = false;
		break;
	case 'NetStream.Play.Stop' :
		_root.navigate.playpause.gotoAndStop("play");
		_root.played = true;
		break;
	case 'NetStream.Play.StreamNotFound' :
		// File not found.
		_root.played = false;
		break;
	case 'NetStream.Buffer.Empty' :
		_root.streamer.seek(0);
		_root.played = true;
		_root.navigate.playpause.gotoAndStop("play");
		_root.streamer.pause(true);
		break;
	case 'NetStream.Buffer.Full' :
		// Play
		break;
	case 'NetStream.Buffer.Flush' :
		//
		break;
	case 'NetStream.Seek.InvalidTime' :
		// Invalid time tried to play.
		break;
	case 'NetStream.Seek.Notify' :
		// The seek operation is complete.
		break;
	}
};

streamer.onCuePoint = function (flvobj:Object) {
	trace ("NetStream.onCuePoint called at " + getTimer () + " ms");
	for (var catman in flvobj) {
		if (catman != "parameters") {
			trace (catman + " = " + flvobj[catman]);
		}
		else {
			trace ("parameters =");
			if (flvobj.parameters != undefined) {
				for (var catman in flvobj.parameters) {
					trace (" " + catman + ": " + flvobj.parameters[catman]);
				}
			}
			else {
				trace ("undefined");
			}
		}
	}
	trace ("---------");
};

/*****************************************************************
  Stage related things, such as resizing.
******************************************************************/

Stage.scaleMode = "noScale";
Stage.align = "TL";
Stage.showMenu = false;

var stageListener:Object = new Object();
stageListener.onResize = function() {
	centerizeTools();
	centerVideo();
};
Stage.addListener(stageListener);


/*****************************************************************
  Listen for user input via keyboard and mousewheel.
******************************************************************/
/* Available built in codes:

 BACKSPACE:Number
 The key code value for the Backspace key (8).

 CAPSLOCK:Number
 The key code value for the Caps Lock key (20).

 CONTROL:Number
 The key code value for the Control key (17).

 DELETEKEY:Number
 The key code value for the Delete key (46).

 DOWN:Number
 The key code value for the Down Arrow key (40).

 END:Number
 The key code value for the End key (35).

 ENTER:Number
 The key code value for the Enter key (13).

 ESCAPE:Number
 The key code value for the Escape key (27).

 HOME:Number
 The key code value for the Home key (36).

 INSERT:Number
 The key code value for the Insert key (45).

 LEFT:Number
 The key code value for the Left Arrow key (37).

 _listeners:Array [read-only]
 A list of references to all listener objects that are registered with the Key object.

 PGDN:Number
 The key code value for the Page Down key (34).

 PGUP:Number
 The key code value for the Page Up key (33).

 RIGHT:Number
 The key code value for the Right Arrow key (39).

 SHIFT:Number
 The key code value for the Shift key (16).

 SPACE:Number
 The key code value for the Spacebar (32).

 TAB:Number
 The key code value for the Tab key (9).

 UP:Number
 The key code value for the Up Arrow key (38).
*/

var keyListener:Object = new Object();
keyListener.onKeyDown = function () {
	trace("Key.getCode() : " + Key.getCode());
	switch (Key.getCode()) {
		case Key.SPACE :
			// Pause / Play via space button
			if (_root.played) {
				// Pause playback
				_root.navigate.playpause.gotoAndStop("pause");
				_root.played = false;
			}
			else {
				_root.navigate.playpause.gotoAndStop("play");
				_root.played = true;
			}
			_root.streamer.pause();
			break;
		case Key.RIGHT :
			// Seek the video playhead forward for two seconds
			_root.streamer.seek(_root.streamer.time + 2);
			//trace("Seeked by arrow button to " + streamer.time + 2 + " seconds");
			break;
		case Key.LEFT :
			// Seek the video playhead backward for two seconds
			_root.streamer.seek(_root.streamer.time - 2);
			//trace("Seeked by arrow button to " + streamer.time - 2 + " seconds");
			break;
		case Key.CONTROL :
			// Resize the video element by the aspect ratio
			_root.videoplace._width = _root.fileratio * _root.videoplace._height;
			// Place the video screen in the middle of the player.
			centerVideo();
			break;
		case Key.UP :
			// Adjust volume up by 5 steps
			vol += 5;
			if (vol > 97) {
				vol = 100;
			}
			break;
		case Key.DOWN :
			// Adjust volume down by five steps
			vol -= 5;
			if (vol > 3) {
				vol = 0;
			}
			break;
		case Key.SHIFT :
			// Show playlist
			_root.navigate.dropdown.listing._visible = true;
			break;
		case Key.PGUP :
			// Next item in playlist
			if (_root.videoid.length < i + 1) {
				i++;
				startNextVideo(i);
			}
			break;
		case Key.PGDN :
			// Previous item in playlist
			if (i > 0) {
				i--;
				startNextVideo(i);
			}
			break;
		case Key.HOME :
			// Rewind video
			_root.streamer.seek(0);
			break;
		case 87 :
			// w
			// Show webcam if any.
			if (Camera.names.length > 0) {
				_root.webcam = Camera.get();
				_root.navigate.dropdown.selectplay.nowplaying.text = _root.webcam.name;
				_root.videoplace.attachVideo(_root.webcam);
				var camUpd:MovieClip = _root.createEmptyMovieClip("camUpd", _root.getNextHighestDepth());
				camUpd.onEnterFrame = function () {
					_root.subjecto.upperbg2.videoinfo.text  = "activityLevel : " + _root.webcam.activityLevel + newline;
					_root.subjecto.upperbg2.videoinfo.text += "bandwidth : " + _root.webcam.bandwidth + newline;
					_root.subjecto.upperbg2.videoinfo.text += "currentFps : " + _root.webcam.currentFps + newline;
					_root.subjecto.upperbg2.videoinfo.text += "fps : " + _root.webcam.fps + newline;
					_root.subjecto.upperbg2.videoinfo.text += "height : " + _root.webcam.height + newline;
					_root.subjecto.upperbg2.videoinfo.text += "index : " + _root.webcam.index + newline;
					_root.subjecto.upperbg2.videoinfo.text += "motionLevel : " + _root.webcam.motionLevel + newline;
					_root.subjecto.upperbg2.videoinfo.text += "motionTimeOut : " + _root.webcam.motionTimeOut + newline;
					_root.subjecto.upperbg2.videoinfo.text += "muted : " + _root.webcam.muted + newline;
					_root.subjecto.upperbg2.videoinfo.text += "name : " + _root.webcam.name + newline;
					_root.subjecto.upperbg2.videoinfo.text += "quality : " + _root.webcam.quality + newline;
					_root.subjecto.upperbg2.videoinfo.text += "width : " + _root.webcam.width + newline;
					/*for (var sks in _root.webcam.names) {
						_root.subjecto.upperbg2.videoinfo.text += "names[" + sks + "] : " + _root.webcam.names[sks] + newline;
					}*/
				};
				_root.subjecto.upperbg2.videoinfo.mouseWheelEnabled = true;
			}
			else {
				// No webcams available.
				_root.subjecto.upperbg2.subtex.text = "You don't seem to have a Web Camera available";
			}
			break;
	}
};

keyListener.onKeyUp = function () {
	switch (Key.getCode()) {
		case Key.SHIFT :
			// Hide playlist
			_root.navigate.dropdown.listing._visible = false;
			break;
	}
};

Key.addListener(keyListener);


// Listen for mousewheel to adjust the sound
// Availability: ActionScript 1.0; Flash Player 6 - (Windows only).
var wheelListener:Object = new Object();
wheelListener.onMouseWheel = function(delta:Number) {
	if (vol < 101 && vol > -1) {
		vol += delta * 2;
		if (vol > 100) {
			vol = 100;
		}
		if (vol < 0) {
			vol = 0;
		}
	}
};
Mouse.addListener(wheelListener);


/****************************************************************
  Look for translation
*****************************************************************/

function translate(index:String, lang:Object):String {
	for (var inx in lang) {
		if (inx == index) {
			return lang[inx];
		}
	}
	return index;
}


/*****************************************************************
  Create the graphical playlist
******************************************************************/

function createItemInPlaylist(container:MovieClip, ii:Number, colors:Object):Void {
	// Dimensions of the box
	var bLeft:Number = 0;
	var bTop:Number = 0;
	var bRight:Number = 145;
	var bBottom:Number = 19;

	var s:Number = ii + 1;
	var yloc:Number = _root.navigate.dropdown._y - 23 - ((bBottom + 0.5) * ii);
	//trace("Playlist duplicate : " + ii);
	var kissa = container.duplicateMovieClip("item_" + ii, container._parent.getNextHighestDepth(), {_visibility:false});
	var mcfill = kissa.createEmptyMovieClip("fill_" + ii, kissa.getNextHighestDepth());
	//trace("Movieclip duplicate : " + kissa);
	kissa._y = yloc;
	//trace("_y of current item " + ii + " : " + getProperty(kissa, _y));
	// Create the fill
	mcfill.beginFill(colors.fills);
	mcfill.lineTo(bRight, bTop);
	mcfill.lineTo(bRight, bBottom);
	mcfill.lineTo(bTop, bBottom);
	mcfill.lineTo(bTop, 2);
	mcfill.endFill();

	trace("mcfill : " + mcfill + ", colors.fills : " + colors.fills);

	// Create the outlines
	kissa.lineStyle(2, colors.outlines, 100);
	kissa.lineTo(bRight, bTop);
	kissa.lineTo(bRight, bBottom);
	kissa.lineTo(bTop, bBottom);
	kissa.lineTo(bTop, bTop);
	// Define the style for the text
	var txtstyle:TextFormat = new TextFormat();
	txtstyle.font = "_sans";
	txtstyle.size = 11;
	txtstyle.color = colors.txt;
	txtstyle.bold = false;
	txtstyle.align = "left";
	// Create the text
	kissa.createTextField("isoption", ii + s, bLeft, bTop, bRight, bBottom);
	kissa.isoption.selectable = false;
	kissa.isoption.wordWrap = false;
	//kissa.isoption.embedFonts = true;
	kissa.isoption.background = false; // if true, bgcolor change not possible.
	kissa.isoption.antiAliasType = "advanced";
	kissa.isoption.sharpness = 0;
	kissa.isoption.html = true;
	kissa.isoption.setTextFormat(txtstyle);
	kissa.isoption.htmlText = this.title[ii];

	//var current_color:ColorTransform = new ColorTransform();
	// Set the action for pressing
	mcfill.onPress = function () {
		// Max number this will catch is 99.
		// If the number is under 10, the first part will be _.
		var candi1:String = this._name.substr(-2, 2);
		var candi2:Array = candi1.split("");
		// Test which one is suitable for usage.
		if (candi2[0] == "_") {
			var kekkonen:String = candi2[1];
		}
		else {
			var kekkonen:String = candi1;
		}
		/*trace("candi1 : " + candi1);
		trace("candi2[0] : " + candi2[0]);
		trace("candi2[1] : " + candi2[1]);
		trace("Kekkonen : " + kekkonen);*/
		// Choose the file to be played also the title
		startNextVideo(Number(kekkonen));
		trace("videofile : " + _root.videofile);
		// Set list invisible.
		_root.navigate.dropdown.listing._visible = false;
		// When the video which is behind this button is watched,
		// change the background color of the button.
		// Color transform
		var current_transform:Transform = new Transform(this);
		var current_color:ColorTransform = new ColorTransform();
		current_color.rgb = colors.pld;
		this.transform.colorTransform = current_color;
		//trace("rgb : " + current_color.rgb + ", base16: " + current_color.rgb.toString(16));
		//trace("rgb : " + this.transform.colorTransform.rgb + ", base16: " + this.transform.colorTransform.rgb.toString(16));
	};
}


/*****************************************************************
  Create the playlist
******************************************************************/

function createPlaylist(subject:Array, listClip:MovieClip, colors:Object):Void {
	// Create a empty movieclip for the list to be in
	var container:MovieClip = listClip.createEmptyMovieClip("container", this.getNextHighestDepth());
	// Order the list to be shown by the numbers in the list, first in the bottom.
	for (var ii in subject) {
		createItemInPlaylist(container, Number(ii), colors);
	}
}

/*****************************************************************
  Place the subject panel and the navigation panel in the center of the player
******************************************************************/

function centerizeTools():Void {
	// Place the timeline, etc. on the bottom area.
	_root.navigate._y = Stage.height - 30;
	// ... in the center.
	_root.navigate._x = Stage.width / 2 - navigate._width / 2;
	// Place the subject panel to the top area.
	_root.subjecto._y = 0;
	_root.subjecto._x = Stage.width / 2 - subjecto._width / 2;
	//trace("Stage.height : " + Stage.height);
	//trace("Stage.width : " + Stage.width);
	_root.videoresize._y = Stage.height / 2;
	_root.videoresize._x = Stage.width / 2;
}


/*****************************************************************
  Place the video element in the center of the stage
******************************************************************/

function centerVideo():Void {
	// Place the video screen in the middle of the player.
	_root.videoplace._x = Stage.width / 2 - _root.videoplace._width / 2;
	_root.videoplace._y = Stage.height / 2 - _root.videoplace._height / 2;
	trace("Video location y: " + _root.videoplace._y + ", Video location x: " + _root.videoplace._x);
}


/*****************************************************************
  Hide the volume adjustment bar
******************************************************************/

function volcontrolhide():Void {
	_root.dragvolume = false;
	_root.navigate.volcontrol.voladjust.volslider.stopDrag();
	_root.navigate.volcontrol.voladjust._visible = false;
	// Make the are fully visible again.
	_root.navigate.volcontrol.showslider._alpha = 100;
}


/*****************************************************************
  Resize the video
******************************************************************/

function resizeVideoAspect(fwidth:Number, fheight:Number):Void {
	_root.fileratio = fwidth / fheight;
	var playeratio:Number = Stage.width / Stage.height;
	//trace("Video size ratio : " + _root.fileratio + ", Player ratio : " + playeratio);
	// Which is bigger, height or width
	if (_root.fileratio > playeratio) {
		// Resize by width, if needed.
		if (fwidth > Stage.width) {
			_root.videoplace._width = Stage.width;
			_root.videoplace._height = _root.videoplace._width / _root.fileratio;
			//trace("New width: " + _root.videoplace._width + ", New height: " + _root.videoplace._height);
		}
		else {
			_root.videoplace._width = fwidth;
			_root.videoplace._height = fheight;
		}
	}
	else {
		// Resize by height, if needed.
		if (fheight > Stage.height) {
			_root.videoplace._height = Stage.height;
			_root.videoplace._width = _root.videoplace._height * _root.fileratio;
			//trace("New width: " + _root.videoplace._width + ", New height: " + _root.videoplace._height);
		}
		else {
			_root.videoplace._width = fwidth;
			_root.videoplace._height = fheight;
		}
	}
	// Place the video screen in the middle of the player.
	centerVideo();
}


function resizeVideoManual(element:MovieClip, additionW:Number, additionH:Number):Void {
	element._width  += additionW;
	element._height += additionH;
	centerVideo();
}


function startNextVideo(inx:Number):Void {
	_root.videofile = _root.transfer + _root.videoid[inx] + ".flv";
	_root.subjecto.upperbg2.subtex.text = _root.subject[inx];
	_root.navigate.dropdown.selectplay.nowplaying.text = _root.title[inx];
	_root.streamer.play(_root.videofile);
}



function argb2hex(a:Number, r:Number, g:Number, b:Number):Number {
    return (a << 24 | r << 16 | g << 8 | b);
}

function hex2argb(val:Number):Object {
    var col:Object = new Object();
    col.alpha = (val >> 24) & 0xFF;
    col.red   = (val >> 16) & 0xFF;
    col.green = (val >> 8)  & 0xFF;
    col.blue  =  val        & 0xFF;
    return col;
}


