﻿/*****************************************
Tsuka - Flash video player: standalone version

Jukka Paasonen
http://paazio.nanbudo.fi/
paazio [at] users.sourceforge.net

The Q Public License Version 1.0
http://www.opensource.org/licenses/qtpl.php

******************************************/

// FLV files are either dragged over or opened via dialog and then played.

// Start SW3 interface.
swInterface.init();
// Enable drag and dropping.
swWindow.DragDrop.enable();

// Which server side script is to be used to transfer the FLV files?
var transfer:String = "flvfiles/";

// Get the list of videos to play, XML format it is.
// The regocnition of the owner of the list, is based on session id.
var tsukalist:String = "tsukalist.xml";


#include "tsukaplayer_functions.as"

/*****************************************************************
  A lot of things should be hidden by default.
******************************************************************/
navigate._visible = false;
navigate.buflevel.info._visible = false;
navigate.dropdown.listing._visible = false;
navigate.volcontrol.voladjust._visible = false;
subjecto._visible = false;
subjecto.upperbg2._visible = false;
videoresize._visible = false;
navigate.timeline._xscale = 0;

/*****************************************************************
  A lot of variables should be set false by default.
******************************************************************/
var commanded:Boolean = false;
var defined:Boolean = false;
var dragvolume:Boolean = false;
var pl_loaded:Boolean = false;
var played:Boolean = false;
var resized:Boolean = false;

/*****************************************************************
  Some other defaults are applied.
******************************************************************/
var curMeta:Object = new Object();
var subject:Array = new Array();
var title:Array = new Array();
var videoid:Array = new Array();
var i:Number = 0;
var vol:Number = 75;
var colors:Object = {outlines:0x666666, fills:0xFFFFFF, bg:0x38B549, txt:0xFF0000, pld:0xFF4455}; // outlines, fills, background, text, played

/*****************************************************************
  NetStream and NetConnections, global Sound object
******************************************************************/
var connectiva:NetConnection = new NetConnection();
connectiva.connect(null);
var streamer:NetStream = new NetStream(connectiva);
streamer.setBufferTime(2);
// Attach the streamer object to the video presentation object.
videoplace.attachVideo(streamer);

//////////////// Sound object for volume control ///////////////
var soundset:Sound = new Sound();
// Initial volume is 75 (0..100).
soundset.setVolume(vol);


/*****************************************************************
  Open file(s)
******************************************************************/

function filesOpened(success:Boolean, folder:String, files:Array) {
	// If it was success, place them in the playlist
	if (success) {
		for (var oneName in files) {
			_root.videoid.push (files[oneName]);
			_root.title.push (files[oneName]);
			_root.subject.push (folder + "/" + files[oneName]);
		}
		_root.transfer = folder + "/";
		// Run the definer.
		definer();
		_root.commanded = true;
		navigate.dropdown.selectplay.nowplaying.text = folder + "\\" + files["0"];
	}
	else {
		trace("Opening files has failed.");
	}
}


/*****************************************************************
  Drag and drop files to be played
******************************************************************/

var dropper:Object = new Object();
dropper.onDragDropFile = function(files:Array) {
	trace("onDragDropFile was launched by using file");
	// sort file list
	files.sort(Array.CASEINSENSITIVE);
	for (var tsok in files) {
		var part1 = files[tsok].split("/");
		var part2 = part1.split("\\");
		videoid.push (files[tsok]);
		title.push (files[tsok]);
		subject.push (files[tsok]);
	}
	_root.transfer = "";
	// Run the definer.
	definer ();
	_root.commanded = true;
	_root.navigate.dropdown.selectplay.nowplaying.text = files["0"];
};
swEvents.addListener(dropper);


/*****************************************************************
  Button actions which can exist all the time
******************************************************************/

navigate.dropdown.selectplay.onPress = function () {
	// Browse for files and display them on the textfield "opened".
	var extensions:Array = ["Flash video", "*.flv"];
	swSystem.Dialogs.BrowseForFiles_Open("", extensions, "", "Open Flash video file(s)", filesOpened, this);
};


/*****************************************************************
  Definer function to define all the actions after the playlist has been loaded.
******************************************************************/

function definer () {
	centerizeTools();
	//////////// Initial values and settings ///////////////
	// Name of the first clip
	_root.videofile = _root.transfer + _root.videoid[_root.i];
	_root.subjecto.upperbg2.subtex.text = _root.subject[_root.i];
	_root.navigate.dropdown.selectplay.nowplaying.text = _root.title[_root.i];
	// Start to play the first in the list
	_root.streamer.play (_root.videofile);

	////////// Button actions ///////////////////////
	_root.navigate.dropdown.selectplay.onPress = function () {
		// Show the playlist if it is not visible
		if (_root.navigate.dropdown.listing._visible) {
			_root.navigate.dropdown.listing._visible = false;
		}
		else {
			_root.navigate.dropdown.listing._visible = true;
		}
	};
	_root.navigate.dropdown.selectplay.onRollOver = function () {
		// Show the playlist.
		_root.navigate.dropdown.listing._visible = true;
	};

	_root.navigate.playpause.onPress = function () {
		// Play or pause playback
		if (_root.played) {
			this.gotoAndStop ("pause");
			_root.played = false;
			_root.streamer.pause (false);
		}
		else {
			this.gotoAndStop ("play");
			_root.played = true;
			_root.streamer.pause (true);
		}
	};


	_root.navigate.timefill.onPress = function () {
		// Set the seek here when clicked.
		var whereto = ((_root._xmouse - _root.navigate.timefill._x) / _root.navigate.timefill._width) * _root.totalduration;
		// Round to be accurate as 1/100 second
		whereto = Math.round (whereto * 100) / 100;
		//trace("_root._xmouse : " + _root._xmouse);
		//trace("_root.navigate.timefill._xmouse : " + _root.navigate.timefill._xmouse);
		//trace("_root.navigate.timeline._x : " + _root.navigate.timeline._x);
		//trace("_root.navigate.timeline._width : " + _root.navigate.timeline._width);
		//trace("_root.totalduration : " + _root.totalduration);
		trace ("Seek sent to : " + whereto + " seconds");
		_root.streamer.seek (whereto);
		trace ("True location of seek : " + _root.streamer.time);
	};


	/////// Run when a video file is loaded ////////////////

	// Definition for actions has been done.
	_root.defined = true;
}
/////////////// Run all the time /////////////////////
// This is to be run 15 times in every second.
_root.onEnterFrame = function () {
	// See if the definition for other instruments has been runned
	if (_root.defined) {
		// If mouse is placed low, show the navigation panel.
		if (_root._ymouse > (Stage.height - 100)) {
			_root.navigate._visible = true;
		}
		else {
			// Hide only if playlist is not visible
			if (_root.navigate.dropdown.listing._visible == false) {
				_root.navigate._visible = false;
			}
		}
		// Show the subject of the file if mouse is at high location.
		if (_root._ymouse < 100) {
			_root.subjecto._visible = true;
		}
		else {
			_root.subjecto._visible = false;
		}
		// Show the video resize element
		if (_root._ymouse > 240 && _root._ymouse < 298 && _root._xmouse > 370 && _root._xmouse < 490) {
			_root.videoresize._visible = true;
		}
		else {
			_root.videoresize._visible = false;
		}
		/*****************************************************************
		  This area is driven only if the timeline is visible.
		  This should reduse the prosessing power required from the user.
		******************************************************************/
		if (_root.navigate._visible) {
			// Set the correct amount for scaling of the timeline.
			_root.navigate.timeline._xscale = _root.streamer.bytesLoaded / _root.streamer.bytesTotal * 100;
			// Locate the slider there where the time is.
			_root.navigate.tslider._x = _root.navigate.timeline._x + (_root.streamer.time / _root.totalduration) * _root.navigate.timeline._width;
			// Show the current time of total
			_root.navigate.tslider.timers.times.text = Math.round (_root.streamer.time) + " s";
			if (_root.dragvolume) {
				trace ("Volume dragging is on");
				// Since the volume slider is dragger, do the actual drag effect.
				// When slider is at _y = -57.5, volume is 100,
				// when slider is at _y = -2.5, volume is 0.
				// Totalmovement of volslider is 55 px.
				_root.vol = Math.floor (-1 * (100 / 55) * (_root.navigate.volcontrol.voladjust.volslider._y + 2));
			}
			// Show the current volume
			_root.navigate.volcontrol.volvalue.text = _root.vol;
			// Set the current volume
			_root.soundset.setVolume (_root.vol);
			// Check for the buffertime.
			var bufper = Math.min(Math.round(_root.streamer.bufferLength/_root.streamer.bufferTime * 100), 100);
			//trace("Length: " + _root.streamer.bufferLength + "\t" + "Time: " + _root.streamer.bufferTime + "\t" + "Buffer: " + bufferPct + "%");
			// Scale the bar to show the current status.
			_root.navigate.buflevel.fill._yscale = bufper;
		}
		// Resize video element.
		if (_root.resized) {
			_root.videoplace._width = _root.videoplace._width + _root._xmouse - _root.resizeinit_x;
			_root.videoplace._height = _root.videoplace._height + _root._ymouse - _root.resizeinit_y;
			centerVideo();
		}
	}
	else if (!_root.commanded) {
		// Run the definer.
		definer ();
		_root.commanded = true;
	}
};



stop();