<?php
/**
* Tsuka - Functions
* @author Jukka Paasonen
* @see http://paazio.nanbudo.fi/
* 
* @lisense The Q Public License Version 1.0
*          http://www.opensource.org/licenses/qtpl.php
*
* @package Tsuka
* @copyright paazio [at] users.sourceforge.net 2005-2007
*
* This file requires atleast PHP version 3.0.9
*/

// Create new session
function createsession() {
	$uip = $_SERVER['REMOTE_ADDR'];
	$_SESSION['id'] = md5($uip.rand().time());

	// Language used by the browser client
	if (isset($_SERVER['HTTP_ACCEPT_LANGUAGE'])) {
		$ulang = $_SERVER['HTTP_ACCEPT_LANGUAGE'];
	}
	else {
		$ulang = '';
	}
	// Now set the language of the page.
	if ($ulang != '' && substr($ulang, 0, 2) == 'ja') {
		$_SESSION['lang'] = 'ja';
	}
	else {
		$_SESSION['lang'] = 'en';
	}

	// User client, browser
	$uagent = $_SERVER['HTTP_USER_AGENT'];
	// Host name if any.
	$uhost = gethostbyaddr($uip);
	// Where user came from if any. Cut of http:// since it is redundant information.
	if (isset($_SERVER['HTTP_REFERER'])) {
		$referer = substr($_SERVER['HTTP_REFERER'], 7);
		if ($referer{strlen($referer) - 1} == '/') {
			// Take of the trailing slash.
			$referer = substr($referer, 0, strlen($referer) - 1);
		}
	}
	else {
		$referer = '';
	}

	// Macromedia Flash plugin version, 0 if none
	$flashversion = 0;

	// Check the existence of a Flash player plugin by searching
	// through the HTTP_ACCEPT header for the Flash MIME type.
	if (strpos($_SERVER['HTTP_ACCEPT'], 'application/x-shockwave-flash') === true) {
		// Version must be 6 or higher.
		$flashversion = 6;
	}
	
	$_SESSION['i'] = 0;
	$_SESSION['level'] = 0;
	return array($uip, $uhost, $ulang, $referer, $flashversion, $uagent);
}

// A function for get/post variables cleanup
function cleanerlady(&$dirty) {
	$clean = array();
	foreach ($dirty as $col => $val) {
		// Clean the key by taking white space out.
		$col = preg_replace('/\s/', '', $col);
		if (is_array($val)) {
			$clean[$col] = cleanerlady($val);
		}
		else {
			$clean[$col] = htmlentities(trim($val), ENT_QUOTES);
		}
	}
	return $clean;
}

