<?php
/**
* Tsuka - Project home
* @author Jukka Paasonen
* @see http://paazio.nanbudo.fi/
* 
* @lisense The Q Public License Version 1.0
*          http://www.opensource.org/licenses/qtpl.php
*
* @package Tsuka
* @copyright paazio [at] users.sourceforge.net 2005-2007
*
* This file requires atleast PHP version 4.3.2
*/
require('./initialize.php');
require('./functions.php');

header('Content-type: text/html; charset=UTF-8');

// Clean the possible incoming data.
if (isset($_GET) && is_array($_GET)) {
	$get = cleanerlady($_GET);
}
// Same for post.
if (isset($_POST) && is_array($_POST)) {
	$post = cleanerlady($_POST);
}


// Create session if it doesn't exist.
if (!isset($_SESSION['id'])) {
	// Get information of the visitor
	list($uip, $uhost, $ulang, $referer, $flashversion, $uagent) = createsession();
	
	// Write log of each new visitor.
	$sql = 'INSERT INTO tu_sessions (seid, uip, uhost, ulang, referer, flash, browser) VALUES (\''.$_SESSION['id'].'\', \''.$uip.'\', \''.$uhost.'\', \''.$ulang.'\', \''.$referer.'\', \''.$flashversion.'\', \''.$uagent.'\')';
	$run = $mdb2->query($sql);
	// On success, we do not tell anything
	if (PEAR::isError($run)) {
		$error[] = '42 '.$run->getMessage();
	}
}


// Maybe login occurs sometimes?
if (isset($get['login'])) {
	// Was there a username defined?
	if (isset($post['user']) && $post['user'] != '') {
		// Was there a password defined?
		if (isset($post['pass']) && $post['pass'] != '') {
			// So lets see if it matches on the one found from database.
			$passtry = sha1($post['pass']);
			$sql = 'SELECT level FROM tu_users WHERE user_id=\''.$post['user'].'\' AND password=\''.$passtry.'\' LIMIT 1';
			$run = $mdb2->query($sql);
			if (!PEAR::isError($run)) {
				if ($run->numRows() > 0) {
					// There seems to be a row with the correct values.
					$res = $run->fetchRow();
					$_SESSION['level'] = $res['0'];
					$_SESSION['user'] = $post['user'];
				}
			}
			else {
				$error[] = '66 '.$run->getMessage();
			}
		}
	}
}

// What is to be seen?
//  news		News of the site
//  login		Login form
//  info		Info of the site
//  video		Videos published
//  files		Files of the user
//  profi		User profile
//  encod		Settings for the encoder

//  docs		Documents
//  demo		Demonstration of the player
//  css			Create CSS.

// And what is the minimum level which is allowed to see it?
if (isset($get['dog'])) {
	if ($get['dog'] == 'logou') {
		// Maybe logout occurs sometimes?
		$langtmp = $_SESSION['lang'];
		session_destroy();
		header('Location: '.$_SERVER['PHP_SELF'].'?lang='.$langtmp);
		exit();
	}
	else {
		switch ($get['dog']) {
			case 'news'  : $_SESSION['view'] = 'news';  $lev = 0; break;
			case 'login' : $_SESSION['view'] = 'login'; $lev = 0; break;
			case 'info'  : $_SESSION['view'] = 'info';  $lev = 0; break;
			case 'video' : $_SESSION['view'] = 'video'; $lev = 0; break;
			case 'files' : $_SESSION['view'] = 'files'; $lev = 1; break;
			case 'profi' : $_SESSION['view'] = 'profi'; $lev = 1; break;
			case 'encod' : $_SESSION['view'] = 'encod'; $lev = 2; break;
			default      : $_SESSION['view'] = 'info';  $lev = 0;
		}
		// Now the view of the page is set.
		// Second thing to do is to see if the current user has the
		// required access level to view it.
		if ($_SESSION['level'] < $lev) {
			// Set the "news" page to be viewed, access level not high enought.
			$_SESSION['view'] = 'news';
		}
	}
}
else {
	$_SESSION['view'] = 'news';
}


// Set the language by request if any.
if (isset($get['lang']) && $get['lang'] != '') {
	// Set it if it is enabled as a translation.
	switch ($get['lang']) {
		case 'en' : $_SESSION['lang'] = 'en'; break;
		case 'ja' : $_SESSION['lang'] = 'ja'; break;
		default :   $_SESSION['lang'] = 'en';
	}
}

// See if japanese is enabled
if (!$cf['enable_ja']) {
	$_SESSION['lang'] = 'en';
}

// Increase the session counter.
$_SESSION['i']++;

// Store the list of views
$sql = 'INSERT INTO tu_visits (seid, many, view, lang, dati) VALUES (\''.$_SESSION['id'].'\', \''.$_SESSION['i'].'\', \''.$_SESSION['view'].'\', \''.$_SESSION['lang'].'\', \''.time().'\')';
$run = $mdb2->query($sql);
// On success, we do not tell anything
if (PEAR::isError($run)) {
	$error[] = '142 '.$run->getMessage();
}

$menu = array(
	'news' => 'news',
	'video' => 'video',
	'info' => 'info'
);
if ($_SESSION['level'] > 0) {
	$menu['files'] = 'files';
	$menu['profi'] = 'profi';
}
if ($_SESSION['level'] > 1) {
	$menu['encod'] = 'encod';
}
if ($_SESSION['level'] == 0) {
	$menu['login'] = 'login';
}
else {
	$menu['logou'] = 'logou';
}

// Choose the language file to use and define the way to show date/time.
// Define all the differences between these two languages here.
// Menu array has image name in keyand alternative text in value.
if ($_SESSION['lang'] == 'ja') {
	require_once('lang_ja.php');
	$date = 'Y.m.d H:i';
	$author = 'パアソネン　ユッカ';
	$menu['langu'] = 'en';
}
else {
	require_once('lang_en.php');
	$date = 'd/m/Y - H:i';
	$author = 'Jukka Paasonen';
	if ($cf['enable_ja']) {
		$menu['langu'] = 'ja';
	}
}

echo '<?xml version="1.0" encoding="UTF-8" ?>';
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" 
	"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<?php
echo '<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="'.$_SESSION['lang'].'" lang="'.$_SESSION['lang'].'">';
?>
<head>
	<?php
	echo '<title>'.$lg['title'].' - '.$lg[$_SESSION['view']].'</title>';
	echo '<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />';
	echo '<meta http-equiv="Content-Language" content="'.$_SESSION['lang'].'" />';
	echo '<meta name="language" content="'.$_SESSION['lang'].'" />';
	echo '<meta name="title" content="'.$lg['title'].'" />';
	echo '<meta name="author" content="'.$author.'" />';
	?>	
	<link rel="stylesheet" type="text/css" href="css/tsuka_v1.css" media="all" />
	<link rel="shortcut icon" type="image/x-icon" href="favicon.ico" />
	<link rel="icon" type="image/ico" href="favicon.ico" />
	<script type="text/javascript" src="js/swfobject.js"></script>
	<script type="text/javascript" src="js/tsuka_v1.js"></script>
</head>
<body>

<div id="headarea">
	<div id="tsukalogo">
		<?php
		echo '<a href="http://'.$cf['tsuka_addr'].'/"><img src="img/tsuka_logo.png" alt="'.$lg['title'].'" width="98" height="98" /></a>';
		?>
	</div>
	<div id="banner">
		<?php
		echo $lg['title'];
		?>
	</div>
	<div id="menubar">
		<ul>
			<?php
			foreach ($menu as $m => $s) {
				if ($m == 'langu') $dog = 'lang';
				else $dog = 'dog';
				echo '<li"><a href="'.$_SERVER['PHP_SELF'].'?'.$dog.'='.$s.'" title="'.$lg[$m].'" class="';
				if ($_SESSION['view'] == $s) echo 'current';
				else echo 'menu';
				echo '">'.$lg[$m].'</a></li>';
			}
			?>
		</ul>
	</div>
</div>

<div id="outlines">
<table>
<tr>
	<td id="out_up_left"></td>
	<td id="out_up_center"></td>
	<td id="out_up_right"></td>
</tr>
<tr>
	<td id="out_mid_left"></td>
	<td id="out_mid_center">
<?php
//  news		News of the site
//  login		Login form
//  info		Info of the site
//  video		Videos published
//  files		Files of the user
//  profi		User profile
//  encod		Settings for the encoder
echo '<h1>'.$lg[$_SESSION['view']].'</h1>';
/************************************************

 news		News of the site
 
************************************************/
if ($_SESSION['view'] == 'news') {
	// Newest gossips...



}
/************************************************

 login		Login form
 
************************************************/
else if ($_SESSION['view'] == 'login') {
	echo '<form name="login" action="'.$_SERVER['PHP_SELF'].'?login" method="post" onSubmit="checkfields();">';
	?>
	<input type="text" name="user" class="login" /><br />
	<input type="password" name="pass" class="login" /><br />
	<input type="submit" value="login" class="button" />
	</form><br />
	<?php
}
/************************************************

 info		Info of the site
 
************************************************/
else if ($_SESSION['view'] == 'info') {
	if ($_SESSION['level'] == 0) {
		//echo '<p>';
		// Show possibility to register.
		if (isset($post['username']) && isset($post['password'])) {
			// Registration sent.
			if (strlen($post['realname']) > 4) {
				if (preg_match('/[a-zA-Z_0-9._-]{4,40}/', $post['username'])) {
					if (preg_match('/[a-zA-Z_0-9._-]{4,40}/', $post['password'])) {
						if (preg_match('/[a-zA-Z_0-9._-]+[@]{1}[a-zA-Z_0-9._-]+[.]+[a-zA-Z_0-9]{2,5}$/', $post['email'])) {
							if (strlen($post['description']) > 4) {
								$sql = 'INSERT INTO tu_users (user_id, password, level, email, realname, description, registered) VALUES (\''.$post['username'].'\', \''.sha1($post['password']).'\', 1, \''.$post['email'].'\', \''.$post['realname'].'\', \''.$post['description'].'\', \''.time().'\')';
								$run = $mdb2->query($sql);
								if (!PEAR::isError($run)) {
									echo $lg['usercreated'].'<br />[';
									echo $post['username'].']<br />[';
									echo $post['password'].']';
								}
								else {
									// Failed.
									$error[] = '303 '.$run->getMessage();
								}
							}
							else {
								// Description too short
								echo 'Decription problem';
							}
						}
						else {
							// Email too long/short/illegal characters.
							echo 'Email problem';
						}
					}
					else {
						// Password too long/short/illegal characters.
						echo 'Password problem';
					}
				}
				else {
					// Username too long/short/illegal characters.
					echo 'Username problem';
				}
			}
			else {
				// Realname too short.
				echo 'Real name problem';
			}
		}
		else {
			$reg = array(
				'realname' => 'text',
				'username' => 'text',
				'password' => 'password',
				'email' => 'text',
				'description' => 'text'
			);

			echo '<h1>'.$lg['register'].'</h1>';

			// Show form for registration.
			echo '<form action="'.$_SERVER['PHP_SELF'].'?dog=info" method="post">';
			echo '<table>';
			foreach($reg as $s => $i) {
				echo '<tr><td>'.$lg[$s].'</td><td><input type="'.$i.'" name="'.$s.'" /></td></tr>';
			}
			echo '</table>';
			echo '<input type="submit" value="Register" />';
			echo '</form>';
		}
	}
	//echo '</p>';
}
/************************************************

 video		Videos published
 
************************************************/
else if ($_SESSION['view'] == 'video') {
	// See it there was a request to add stuff to the playlist.
	if (isset($get['list'])) {
		// It is either "many", "continue" or 32 letters long id for one.
		// In case of "many" : add all posted ids to list and watch it.
		// In case of "continue" : add all to list and browse for more.
		// In case of 32 letters long id, watch only it.
		// What ever the case is, an item is always added to the playlist.
		$ok = false;
		$so = false;
		$plist = array();
		if (isset($_SESSION['user'])) {
			$owner = $_SESSION['user'];
		}
		else {
			$owner = $_SESSION['id'];
		}
		if (isset($post['list'])) {
			if ($post['list'] == 'many' || $post['list'] == 'continue') {
				$sql = 'INSERT INTO tu_playlist (userid, created, modified) VALUES (\''.$owner.'\', \''.time().'\', \''.time().'\')';
				for($i = 0; $i < $post['total']; $i++) {
					if (isset($post['add_'.$i]) && $post['add_'.$i] == 'on') {
						$plist[] = $post['item_'.$i];
					}
				}
			}
			if ($post['list'] == 'many') {
				// Add and watch.
				$ok = true;
				$so = true;
			}
			else if ($post['list'] == 'continue') {
				// Add and keep browsing.
				$ok = true;
				$so = false;
			}
		}
		if (strlen($get['list']) == 32) {
			// Add this one and watch it.
			$ok = true;
			$so = true;
			$sql = 'INSERT INTO tu_playlist (userid, created, modified) VALUES (\''.$owner.'\', \''.time().'\', \''.time().'\')';
			$plist[] = $get['list'];
		}
		if ($ok) {
			$run = $mdb2->query($sql);
			if (!PEAR::isError($run)) {
				// Get last insert ID to get the playlist ID.
				$plid = $mdb2->lastInsertId('tu_playlist', 'plid');
				foreach($plist as $item) {
					$sql = 'INSERT INTO tu_playlist_item (plid, videoid) VALUES (\''.$plid.'\', \''.$item.'\')';
					$run = $mdb2->query($sql);
					if (PEAR::isError($run)) {
						echo '<br />Item : '.$item.' was not inserted due some error.';
					}
				}
			}
			else {
				// Failed.
				$error[] = '419 '.$run->getMessage();
			}
		}
		if ($so) {
			?>
			<div id="tsukaplayer">
			</div>
			<script type="text/javascript">
			var so = new SWFObject("tsukaplayer.swf", "playertsuka", "760", "420", "8", "#ffffff", true, "best");
			so.addParam("menu", false);
			so.addVariable("tpver", "3.8");
			so.write("tsukaplayer");
			</script>
			<?php
		}
		echo '<br /><hr /><br />';
	}
	// List available videos with some info first.
	if (isset($get['lims']) && is_numeric($get['lims'])) {
		$lim_s = $get['lims'];
	}
	else {
		$lim_s = 0;
	}
	if (isset($get['limc']) && is_numeric($get['limc'])) {
		$lim_c = $get['limc'];
	}
	else {
		$lim_c = 25;
	}
	$sql = 'SELECT A.video_id, A.subject, A.added, A.user_id, COUNT(B.file_id) as "viewed" FROM tu_videos A LEFT JOIN tu_flvplayes B ON A.video_id=B.file_id GROUP BY A.video_id ASC ORDER BY A.added DESC, A.subject ASC LIMIT '.$lim_s.','.$lim_c;
	$run = $mdb2->query($sql);
	if (!PEAR::isError($run)) {
		if ($run->numRows() > 0) {
			//echo $run->numRows();
			echo '<form action="'.$_SERVER['PHP_SELF'].'?dog=video&amp;list" method="post">';
			echo '<table>';
			echo '<tr>';
			echo '<th></th>';
			echo '<th>'.$lg['subject'].'</th>';
			echo '<th width="260">'.$lg['added'].'</th>';
			echo '<th width="140">'.$lg['user_id'].'</th>';
			echo '<th width="100">'.$lg['viewed'].'</th>';
			echo '</tr>';
			$i = 0;
			while ($res = $run->fetchRow(MDB2_FETCHMODE_ASSOC)) {
				echo '<tr>';
				echo '<td><input type="checkbox" class="tick" name="add_'.$i.'" />';
				echo '<input type="hidden" name="item_'.$i.'" value="'.$res['video_id'].'" /></td>';
				echo '<td><a href="'.$_SERVER['PHP_SELF'].'?dog=video&amp;list='.$res['video_id'].'">'.$res['subject'].'</a></td>';
				echo '<td>'.date($date, $res['added']).'</td>';
				echo '<td>'.$res['user_id'].'</td>';
				echo '<td>'.$res['viewed'].'</td>';
				echo '</tr>';
				$i++;
			}
			echo '<tr>';
			echo '<td>&nbsp;</td>';
			echo '<td colspan="2"><select name="list">';
			echo '<option value="0">&nbsp;</option>';
			echo '<option value="many">'.$lg['plistmany'].'</option>';
			echo '<option value="continue">'.$lg['plistcont'].'</option>';
			echo '</select></td>';
			echo '<td><input type="submit" class="button" value="" /></td>';
			echo '<td>&nbsp;</td>';
			echo '</tr>';
			echo '</table>';
			echo '<input type="hidden" name="total" value="'.$i.'" />';
			echo '</form>';
		}
		else {
			// There is no videos published yet.
		}
		
		$prev = $lim_s - $lim_c;
		$next = $lim_s + $lim_c;
		echo '<p>&nbsp;';
		if ($prev >= 0) {
			echo '<a href="'.$_SERVER['PHP_SELF'].'?dog=video&amp;lims='.$prev.'">['.$prev.']</a>&nbsp;';
		}
		if ($lim_c == $run->numRows()) {
			echo '&nbsp;<a href="'.$_SERVER['PHP_SELF'].'?dog=video&amp;lims='.$next.'">['.$next.']</a>';
		}
		echo '&nbsp;</p>';
	}
	else {
		$error[] = '505 '.$run->getMessage();
	}
}
/************************************************

 files		Files of the user
 
************************************************/
else if ($_SESSION['view'] == 'files' && $_SESSION['level'] > 0) {
	// videos: (video_id, subject, information, added, user_id)
	echo '<h2>'.$lg['upload'].'</h2>';
	// Show the upload form first.
	// Upload here action="
	echo '<form action="upload.cgi?seid='.$_SESSION['id'].'&amp;user='.$_SESSION['user'].'" ';
	echo 'method="post" enctype="multipart/form-data">';
	echo '<input type="file" class="file" name="file1" /><br />';
	echo '<input type="file" class="file" name="file2" /><br />';
	echo '<input type="file" class="file" name="file3" /><br />';
	echo '<input type="submit" value="'.$lg['uploadfiles'].'" ';
	echo 'onClick="showProgress('.$cf['periscopeflash'].')"';
	// window.open(\'periscope.php\',\'periscope\',\'height=220, width=450, toolbar=false\')
	echo '/>';
	echo '</form>';
	echo '<div id="progress">Progress of the upload will be shown here.</div>';
	echo '<br /><hr /><br />';
	echo '<h2>'.$lg['files'].'</h2>';

	// Show the list of current files with some details and opportunity to delete.
	$dir = $cf['userdir'].$_SESSION['user'].'/';
	if (file_exists($dir)) {
		echo '<form action="" method="post">';
		echo '<table>';
		echo '<tr>';
		echo '<th>'.$lg['filepublish'].'</th>';
		echo '<th>'.$lg['filename'].'</th>';
		echo '<th>'.$lg['filesize'].'</th>';
		echo '<th>'.$lg['filecreation'].'</th>';
		echo '<th>'.$lg['filedelete'].'</th>';
		echo '</tr>';
		// List only file having extension.
		$files = glob($dir.'*.*');
		foreach ($files as $filepath) {
			$file = substr($filepath, strlen($dir));
			echo '<tr>';
			echo '<td><input type="radio" class="tick" /></td>';
			echo '<td>'.$file.'</td>';
			echo '<td>'.round(filesize($filepath)/(1024*1024), 0).'</td>';
			echo '<td>'.date($date, filectime($filepath)).'</td>';
			echo '<td><input type="checkbox" class="tick" /></td>';
			echo '</tr>';
		}
		echo '</table>';
		echo '<br />';
		echo '<table>';
		echo '<tr><td width="120">'.$lg['subject'].'</td>';
		echo '<td><input type="text" name="subject" /></td></tr>';
		echo '<tr><td width="120">'.$lg['description'].'</td>';
		echo '<td><textarea name="description"></textarea></td></tr>';
		echo '</table>';
		echo '<br />';
		echo '<input type="submit" value="Publish/Delete" />';
		echo '</form>';
	}
}
/************************************************

 profi		User profile
 
************************************************/
else if ($_SESSION['view'] == 'profi' && $_SESSION['level'] > 0) {
	if (isset($post['realname'])) {
		$sql = 'UPDATE tu_users SET realname=\''.$post['realname'].'\', email=\''.$post['email'].'\', description=\''.$post['description'].'\' WHERE user_id=\''.$_SESSION['user'].'\' LIMIT 1';
		$run = $mdb2->query($sql);
		if (!PEAR::isError($run)) {
			// Check for affected rows...
			echo 'Profile updated';
		}
		else {
			$error[] = '583 '.$run->getMessage();
		}
	}
	$sql = 'SELECT realname, email, description FROM tu_users WHERE user_id=\''.$_SESSION['user'].'\' LIMIT 1';
	$run = $mdb2->query($sql);
	if (!PEAR::isError($run)) {
		if ($run->numRows() > 0) {
			echo '<form action="'.$_SERVER['PHP_SELF'].'?dog=profi" method="post">';
			echo '<table>';
			$res = $run->fetchRow(MDB2_FETCHMODE_ASSOC);
			foreach($res as $name => $value) {
				echo '<tr><td>'.$name.'</td><td><input type="text" name="'.$name.'" value="'.$value.'" /></td></tr>';
			}
			echo '<tr><td></td><td><input type="submit" value="Update" /></td></tr>';
			echo '</table>';
			echo '</form>';
		}
		else {
			// No user in DB.
		}
	}
	else {
		// Failed.
		$error[] = '606 '.$run->getMessage();
	}
}
/************************************************

 encod		Settings for the encoder
 
************************************************/
else if ($_SESSION['view'] == 'encod' && $_SESSION['level'] > 1) {
	if (isset($post['total'])) {
		if ($post['ename_new'] != '' && $post['evalue_new'] != '') {
			// Insert new one
			if (isset($post['active_new']) && $post['active_new'] == 'on') {
					$post['active_new'] = 1;
				}
				else {
					$post['active_new'] = 0;
				}
			$sql = 'INSERT INTO tu_encoder (ename, evalue, active) VALUES (\''.$post['ename_new'].'\', \''.$post['evalue_new'].'\', \''.$post['active_new'].'\')';
			$run = $mdb2->query($sql);
			if (PEAR::isError($run)) {
				$error[] = '627 '.$run->getMessage();
			}
		}
		if ($post['total'] > 0) {
			// Update existing ones if so selected
			for ($i = 0; $i < $post['total']; $i++) {
				if (isset($post['update_'.$i]) && $post['update_'.$i] == 'on') {
					if (isset($post['active_'.$i]) && $post['active_'.$i] == 'on') {
						$post['active_'.$i] = 1;
					}
					else {
						$post['active_'.$i] = 0;
					}
					$sql = 'UPDATE tu_encoder SET ename=\''.$post['ename_'.$i].'\', evalue=\''.$post['evalue_'.$i].'\', active=\''.$post['active_'.$i].'\' WHERE encid=\''.$post['encid_'.$i].'\' LIMIT 1';
					$run = $mdb2->query($sql);
					if (PEAR::isError($run)) {
						$error[] = $run->getMessage();
					}
					echo $sql.'<br />';
				}
			}
		}
	}
	$sql = 'SELECT * FROM tu_encoder';
	$run = $mdb2->query($sql);
	if (!PEAR::isError($run)) {
		echo '<form action="'.$_SERVER['PHP_SELF'].'?dog=encod" method="post">';
		echo '<table>';
		$i = 0;
		if ($run->numRows() > 0) {
			echo '<tr>';
			echo '<th class="w80">'.$lg['update'].'</th>';
			echo '<th>'.$lg['encactive'].'</th>';
			echo '<th>'.$lg['ename'].'</th>';
			echo '<th>'.$lg['evalue'].'</th>';
			echo '</tr>';
			/* TODO: numbers only fields to be checked with JS. */
			while ($res = $run->fetchRow(MDB2_FETCHMODE_ASSOC)) {
				echo '<tr>';
				echo '<td class="w80"><input type="checkbox" name="update_'.$i.'" class="tick" />';
				echo '<input type="hidden" name="encid_'.$i.'" value="'.$res['encid'].'" /></td>';
				echo '<td><input type="checkbox" name="active_'.$i.'" class="tick" ';
				if ($res['active']) echo 'checked="checked" ';
				echo ' /></td>';
				echo '<td><input type="text" name="ename_'.$i.'" class="w200" value="'.$res['ename'].'" /></td>';
				echo '<td><input type="text" name="evalue_'.$i.'" class="w200" value="'.$res['evalue'].'" /></td>';
				echo '</tr>';
				$i++;
			}
			//echo '</table><br /><hr /><br /><table>';
		}
		// Always one empty to add a new one.
		echo '<tr>';
		echo '<th class="w80">'.$lg['create'].'</th>';
		echo '<th>'.$lg['encactive'].'</th>';
		echo '<th>'.$lg['ename'].'</th>';
		echo '<th>'.$lg['evalue'].'</th>';
		echo '</tr>';
		echo '<tr>';
		echo '<td class="w80">&nbsp;</td>';
		echo '<td><input type="checkbox" name="active_new" class="tick" /></td>';
		echo '<td><input type="text" name="ename_new" class="w200" /></td>';
		echo '<td><input type="text" name="evalue_new" class="w200" /></td>';
		echo '</tr>';
		echo '</table>';
		echo '<input type="hidden" name="total" value="'.$i.'" />';
		echo '<input type="submit" value="Update/Create" />';
		echo '</form>';
	}
	else {
		// Failed.
		$error[] = $run->getMessage();
	}

}

// Now all possibilites are gone thru, show some content for them also.
$sql = 'SELECT * FROM tu_content WHERE view=\''.$_SESSION['view'].'\' ORDER BY modified DESC';
$run = $mdb2->query($sql);
if (!PEAR::isError($run)) {
	if ($run->numRows() > 0) {
		while ($res = $run->fetchRow(MDB2_FETCHMODE_ASSOC)) {
			// Show this headline.
			echo '<hr />';
			echo '<h2>'.$res['subject'];
			if ($_SESSION['level'] > 1) {
				// Give a editing/deleting possibility for the admin.
				echo '&nbsp;(<a href="#" onclick="edit_item();">'.$lg['edit'].'</a>/<a href="#" onclick="delete_item();">'.$lg['delete'].'</a>)';
			}
			echo '</h2>';
			echo '<p>'.nl2br($res['content']).'</p>';
			echo '<p class="editedby">'.$res['editor'].' | '.date($date, $res['modified']).'</p>';
		}
	}
	// Empty is not shown...
}
else {
	// Failed.
	$error[] = $run->getMessage();
}








/***************** Editor area starts *************/
// If an update or creation of new, was done and the language is japanese, encode some numerics,
if ((isset($get['create']) || isset($get['update'])) && $_SESSION['level'] > 1) {
	if ($_SESSION['lang'] == 'ja') {
		// Unicode setting from http://www.unicode.org/Public/4.1.0/ucd/Blocks.txt
		// Unified CJK Ideographs
		// Compatibility Ideographs
		// Compatibility Ideo. Suppl.
		// CJK Ideographs Ext. A
		// CJK Ideographs Ext. B
		// Hiragana
		// Katakana
		$convmap = array(
			0x4E00,  0x9FBF,  0, 0xFFFF,
			0xF900,  0xFAFF,  0, 0xFFFF,
			0x2F800, 0x2fA1F, 0, 0xFFFF,
			0x3400,  0x4DBF,  0, 0xFFFF,
			0x20000, 0x2A6DF, 0, 0xFFFF,
			0x3040,  0x309F,  0, 0xFFFF,
			0x30A0,  0x30FF,  0, 0xFFFF
		);
		$subject = mb_encode_numericentity($post['subject'], $convmap, 'iso-8859-1');
		$content = mb_encode_numericentity($post['content'], $convmap, 'iso-8859-1');
	}
	else {
		// Just clean up and that is it.
		$subject = $post['subject'];
		$content = $post['content'];
	}
}

if (isset($get['edit']) && $_SESSION['level'] > 1) {
	// Edit the selected area.
	if (strlen($get['edit']) == 32) {
		// Select the correct from the database.
		$sql = 'SELECT * FROM tu_content WHERE con_id=\''.$get['edit'].'\' LIMIT 1'; 
		$run = $mdb2->query($sql);
		if (!PEAR::isError($run)) {
			if ($run->numRows() > 0) {
				$res = $run->fetchRow(MDB2_FETCHMODE_ASSOC);
				echo '<form action="'.$_SERVER['PHP_SELF'].'?update='.$get['edit'].'" method="post" name="editor">';
				echo '<h1>ID : '.$get['edit'].' | '.$res['view'].'</h1>';
				echo '<i>Previous edit was in '.date($date, $res['modified']).' by '.$res['editor'].'</i><br /><br />';
				echo '<input type="text" name="subject" class="update" value="'.$res['subject'].'" /><br />';
				echo '<textarea name="content" class="update">'.$res['content'].'</textarea><br />';
				echo '<input type="submit" value="Update" class="button" />';
				echo '</form>';
			}
			else {
				// Was not found.
				echo 'Mi scusi, no information with this id.';
			}
		}
		else {
			$error[] = $run->getMessage();
		}
	}
}

// Close the milk bottle and place it back to the freezer.
$mdb2->disconnect();

/***********************************************

End content here.

************************************************/

?>
	</td>
	<td id="out_mid_right"></td>
</tr>
<tr>
	<td id="out_bot_left"></td>
	<td id="out_bot_center"></td>
	<td id="out_bot_right"></td>
</tr>
</table>
</div>


&nbsp;&copy; 
Kalle L&ouml;nnroth 
<?php
if ($_SESSION['lang'] == 'ja') {
	echo '&#12392; ';
}
else {
	echo 'and ';
}
?>
<a href="http://paazio.nanbudo.fi/">Jukka Paasonen</a>
|
<a href="http://sourceforge.net/project/showfiles.php?group_id=154896">Latest release:
<?php	
/** Show the current release with a link to download from sourceforge file list. **/
echo file_get_contents('./CURRENT_RELEASE').'</a> ';
if (function_exists('memory_get_usage')) {
	echo '| '.round(memory_get_usage()/1024).' KB';
}
// See the errors if any.
if (isset($error) && is_array($error)) {
	echo '<div id="debug"><b>There was some errors</b>';
	foreach ($error as $er) {
		if (is_array($er)) {
			echo '<br />'.implode(' ', $er);
		}
		else {
			echo '<br />'.$er;
		}
	}
	echo '</div>';
}

echo '<div id="debug">';
echo '<pre>';/*
echo 'Session : ';
print_r($_SESSION);
echo 'Post orignal : ';
print_r($_POST);*/
echo 'Post encoded : ';
print_r($post);/*
echo 'Get orignal : ';
print_r($_GET);
echo 'Get encoded : ';
print_r($get);
print_r($_SERVER);*/
echo '</pre>';
echo '</div>';

?>
</body>
</html>