<?php
/**
* Tsuka - Initialize Tsuka enviroment
* @author Jukka Paasonen
* @see http://paazio.nanbudo.fi/
* 
* @lisense The Q Public License Version 1.0
*          http://www.opensource.org/licenses/qtpl.php
*
* @package Tsuka
* @copyright paazio [at] users.sourceforge.net 2005-2007
*
* This file requires atleast PHP version 4.0.0
*/
require('./config.php');

// PHP configuration
ini_set('display_errors', $cf['display_errors']);
ini_set('error_log', $cf['error_log']);
ini_set('session.save_path', $cf['save_path']);
ini_set('session.save_handler', $cf['save_handler']);
ini_set('log_errors', '1');
ini_set('error_reporting', $cf['error_reporting']);

// Lowercase all names
ini_set('sqlite.assoc_case', '2');

// Make urls Xhtml compliant
ini_set('arg_separator.output', '&amp;');

// What would be the primary include path?
//ini_set('include_path', './lib/pear'.PATH_SEPARATOR.ini_get('include_path'));

// Set own session name
session_name('TSUKA');
session_start();


// MDB2 library to access database.
require_once 'MDB2.php';


$options = array(
    'debug'       => 2,
    'portability' => MDB2_PORTABILITY_ALL
);

// Does not connect. Yet.
$mdb2 =& MDB2::factory($cf['dsn'], $options);

if (PEAR::isError($mdb2)) {
	header('Content-type: text/plain');
	echo ($mdb2->getMessage());
	exit("\nSorry, could not connect to the database and because of that, cannot show any content for this site.\nPlease try again later.");
}

// How about other errors?
// Check for all the directories and encoder binary if it is enabled.
if ($cf['save_handler'] == 'files') {
	if (!file_exists($cf['save_path'])) {
		exit("\nCheck configuration, session.save_path not existing");
	}
}
if (!file_exists($cf['tmpdir'])) {
	exit("\nCheck configuration, tmp dir not existing");
}
if ($cf['encenabled']) {
	if (!file_exists($cf['enclocation'])) {
		exit("\nCheck configuration, encoder binary not existing");
	}
	if (!file_exists($cf['flvtool']) && !preg_match('/svn/', $cf['encoder'])) {
		exit("\nCheck configuration, flvtool not existing");
	}
}
if (!file_exists($cf['basedir'])) {
	exit("\nCheck configuration, basedir not existing");
}
if (!file_exists($cf['flvdir'])) {
	exit("\nCheck configuration, FLV dir not existing");
}
if ($cf['tsuka_addr'] == '') {
	exit("\nCheck configuration, Tsuka address is empty");
}

?>