/*****************************************

Tsuka - JavaScript common functions

Jukka Paasonen
http://paazio.nanbudo.fi/
paazio [at] users.sourceforge.net

The Q Public License Version 1.0
http://www.opensource.org/licenses/qtpl.php

******************************************/


/*
	Check for empty and/or right kind of content.
*/

function checkFields(field, contype) {
	// Check for empty fields.
	if (field.value == "") {
		return false;
	}
	return true;
}

function showProgress(periscope) {
	// Replace text with progess bar made in flash or open a new window.
	if (periscope) {
		// swf, id, w, h, ver, c, useExpressInstall, quality, xiRedirectUrl, redirectUrl, detectKey
		var so = new SWFObject("periscope.swf", "periscope", "500", "60", "6", "#ffffff", false, "best");
		so.addParam("menu", false);
		so.write("progress");
	}
	else {
		document.getElementById("progress").innerHTML = "Opening a new window for progress bar...";
		monkey = window.open("", "monkey", "height=80,width=520,toolbar=0,menubar=0,status=0");
		monkey.document.so = new SWFObject("periscope.swf", "periscope", "500", "60", "6", "#ffffff", false, "best");
		monkey.document.so.addParam("menu", false);
		monkey.document.write('<div id="progress">empty div</div>');
		monkey.document.so.write("progress");
		monkey.document.close();
	}	
}

/*
	Check the correctness of a date.

	Accepted DOM types are:
	 - text
	 - textarea
	 - select-one.
*/

function checkDate(element, separator) {
	var monthLength = new Array(31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);
	var yearRange = new Array(1900, 2100);
	// Default separator
	if (!separator)
		separator = "/";

	if (element.type == "text" || element.type == "textarea") {
		var pizza = texts.split(separator);
		if (pizza.length < 3)
			return false;
		var day = pizza[0];
		var month = pizza[1];
		// Do not include hours etc in year...
		var year = pizza[2];
		if (year.length > 4) {
			var temp = year.split(" ");
			var year = temp[0];
		}
	}
	else if (element.type == "select-one.") {
		var parts = element.name.split("_");
		var element_m = element.form[parts[0] + "_month"];
		var element_y = element.form[parts[0] + "_year"];
		var day = parseInt(element.options[element.options.selectedIndex].value);
		var month = parseInt(element_m.options[element_m.options.selectedIndex].value);
		var year = parseInt(element_y.options[element_y.options.selectedIndex].value);
	}
	else {
		return false;
	}

	// First check that all variables are set
	if (!day || !month || !year)
		return false;

	// Check if we are on a Running year
	if (year%4 == 0)
		monthLength[1] = 29;

	// Is the month correct?
	if (month < 1 || month > 12)
		return false;

	// Is the day correct?
	if (day > monthLength[month-1])
		return false;

	// Is the year correct?
	if (year.length != 4)
		return false;
	if (year < yearRange[0])
		return false;
	if (year > yearRange[1])
		return false;

	// So far seems ok...
	return true;
}

function runDateCheck(element, separator, colore1, colore0) {
	if (!element || !colore)
		return false;
	
	if (!separator)
		separator = ".";
	
	if (checkDate(element, separator)) {
		element.style.backgroundColor = colore1;
	}
	else {
		element.style.backgroundColor = colore0;
	}
}

function edit_item() {
}

function delete_item() {
}

