<?php
/**
* Tsuka - Upload status information
* @author Jukka Paasonen
* @see http://paazio.nanbudo.fi/
* 
* @lisense The Q Public License Version 1.0
*          http://www.opensource.org/licenses/qtpl.php
*
* @package Tsuka
* @copyright paazio [at] users.sourceforge.net 2005-2007
*
* This file requires atleast PHP version 4.3.0
*/
require_once('./initialize.php');
/**
* Choose the output type by using get variable "type":
*  - 0  html graphical bar (default)
*  - 1  for flash the total size of the upload
*  - 2  for flash the current size of uploaded data
*/

// Settings.
if ($_SESSION['level'] > 2) {
	$debug = true;
}
else {
	$debug = false;
}

$file_dat = $cf['tmpdir'].$_SESSION['id'].'.p';
$file_len = $cf['tmpdir'].$_SESSION['id'].'.f';
$file_end = $cf['tmpdir'].$_SESSION['id'].'.s';
$interval = '2';

foreach ($_GET as $gk => $gv) {
	if (is_numeric($gv)
		$got[$gk] = (int)trim($gv);
	else
		$got[$gk] = (int)trim($gv);
}

// Starting timer.
if (isset($got['time0']) && $got['time0'] > 0) {
	$time0 = $got['time0'];
}
else {
	$time0 = time();
}

// Time now.
$time9 = time();

// Elapsed seconds.
$time1 = $time9 - $time0;

// Total size of the uploaded files.
if (isset($got['tsize'])) {
	$tsize = $got['tsize'];
}
else  {
	if (file_exists($file_len)) {
		$tsize = (int)trim(file_get_contents($file_len));
	}
	else {
		$tsize = false;
	}
}

// See if the total size of the upload is already set.
if ($tsize) {
	// Then continue to see more.
	// Get the filesize how much is currently uploaded.
	if (file_exists($file_dat)) {
		$csize = filesize($file_dat);
	}
	else {
		if (isset($got['csize'])) {
			$csize = $got['csize'];
			if ($debug) {
				echo '<br />csize = '.$csize.'<br />';
			}
		}
		else {
			$csize = false;
			if ($debug) {
				echo '<br />get[csize] was not set.<br />';
			}
		}
	}

	// See if we could fetch the current size of the uploaded data.
	if ($csize) {
		// Uploaded bytes / time used = speed
		$Bps = $csize / $time1;
		$KiBps = round($Bps / 1024, 2);

		// How much is left to be uploaded.
		$bytesleft = $tsize - $csize;

		// How many percent.
		$percent = round(($csize / $tsize) * 100, 0);
	}
	else {
		$error = 'Unable to fetch the size of the currently uploaded data.';
	}
}
else {
	$error = 'Unable to fetch the size of the total upload.';
}


// Set the type
if (isset($got['type'])) {
	$type = $got['type'];
}
else {
	$type = 0;
}

// Give some output.
// According to 
// http://livedocs.macromedia.com/flash/8/main/00002329.html
// content type application/x-www-form-urlencoded.
if ($type == 1 || $type == 2) {
	header('Content-type: application/x-www-form-urlencoded; charset=UTF-8');
	if ($type == 1)
		echo 'total='.$tsize;
	else
		echo 'current='.$tsize;
}
else {
	header('Content-type: text/html; charset=UTF-8');
	?>
	<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" 
		"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
	<?php
	echo '<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="'.$_SESSION['lang'].'" lang="'.$_SESSION['lang'].'">';
	?>
	<head>
		<title>Tsuka - Upload status information</title>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
	<?php
	// See if the upload has ended, or should the page be refreshed.
	if (file_exists($file_end)) {
		if (file_exists($file_len)) {
			unlink($file_len);
			if ($debug) {
				echo '<br />file_len existed so it was deleted.<br />';
			}
		}
		unlink($file_end);
		$ended = true;
	}
	else {
		echo '<meta HTTP-EQUIV="Refresh" CONTENT="'.$interval.'; URL='.$_SERVER['PHP_SELF'].'?time0='.$time0;
		if (!isset($error)) {
			echo '&amp;tsize='.$tsize.'&amp;csize='.$csize;
		}
		echo '">';
		$ended = false;
	}
	?>
	<link rel="stylesheet" type="text/css" src="css/periscope.css" />

	</head>
	<body>
	<div class="area">
	<table class="info">

	<?php
	if (isset($error)) {
		echo '<tr><td>'.$error.'</td></tr>';
	}
	else {
		echo '<tr><td width="80">Uploaded : </td><td>'.round($csize/(1024*1024), 2).' MBytes</td></tr>';
		echo '<tr><td>Total : </td><td>'.round($tsize/(1024*1024), 2).' MBytes</td></tr>';
		echo '<tr><td>Left : </td><td>'.round($bytesleft/(1024*1024), 2).' MBytes</td></tr>';
		echo '<tr><td>Speed : </td><td>'.$KiBps.' KBps</td></tr>';
	}

	echo '</table><br />';

	if (!isset($error)) {
		?>
		<table class="meter">
		<tr>
		<td class="done"></td>
		<td class="left"></td>
		</tr>
		</table><br />
		<?php
		$min = floor($time1/60);
		$sec = $time1 - $min * 60;
		echo $percent.'% done in '.$min.' min, '.$sec.' sec.';
	}
	if ($ended) {
		echo '<br /><b>Upload has ended. You may close the window.</b>';
	}
	?>
	</div>
	</body>
	</html>
	<?php
}
?>