#!/usr/bin/perl -w

###############
#
# Tsuka - Video uploader
#
# Jukka Paasonen
# http://paazio.nanbudo.fi/
# paazio [at] users.sourceforge.net
#
# The Q Public License Version 1.0
# http://www.opensource.org/licenses/qtpl.php
#
###############

use strict;

#use PHP::Include(DEBUG => 0);
#include_php_vars("config.php");

my $userbasedir = "/tsuka/users/";
my $tmpdir = "/tsuka/tmp/";
my $whereafter = "index.php?dog=files";
my $maxupload	= 180*1024*1024; 
# 180 MiB

# Database related info. Used for logging purposes only.
my $db_host = 'localhost';
my $db_name = 'tsuka';
my $db_user = 'tsuka';
my $db_pass = 'tsuka';
my $db_type = 'mysql';
my $db_port = 3306;


##
# Start the script. No variable changes after this line, please.
##

use CGI;
use Fcntl qw(:DEFAULT :flock);
use File::Temp qw/ tempfile tempdir /;
use DBI;
#use Net::MySQL;

# Either one to be used for debugging.
#use Carp;
#use CGI::Carp qw(fatalsToBrowser);
# Note that fatalsToBrowser does not work with mod_perl version 2.0 and higher.

use Env;

#carp "Starting script";


# Allow uploads. This is important.
$CGI::DISABLE_UPLOADS = 0;


# Debug temporary files
$File::Temp::DEBUG = 1;

#####################

# Get all the information from the post.
my $username = '';
my $seid = '';
foreach my $query (split(/&/, $ENV{'QUERY_STRING'})) {
	my @peace = split(/=/, $query);
	if ($peace[0] eq 'user') {
		$username = $peace[1];
		# Now there is still missing a check for double dots ../../../
	}
	elsif ($peace[0] eq 'seid') {
		$seid = $peace[1];
	}
}

sub goodbye {
	close(STDIN);
	my $mes = shift;
	print "Content-type: text/html\n\n";
	print "<br /><b>$mes</b><br />\n";
	exit;
}

my $totaldata = $ENV{'CONTENT_LENGTH'};

# Get session informations needed.
$userbasedir .= $username;
my $file_data = $tmpdir.$seid.".p";
my $file_lenght = $tmpdir.$seid.".f";
my $file_ending = $tmpdir.$seid.".s";
my $bytesread = 0;

$| = 1;



# Start debugging variables.
#carp "session id: $seid";
#carp "username: $username";
#carp "userbasedir: $userbasedir";
#carp "total data size: $totaldata";
#carp "QUERY_STRING: $ENV{'QUERY_STRING'}";

$| = 1;



# Delete if exists a previous data file.
if (-e "$file_data") {
	unlink("$file_data");
	#carp "Unlinked: $file_data";
}

# Delete if exists a previous signal of upload ending file.
if (-e "$file_ending") {
	unlink("$file_ending");
	#carp "Unlinked: $file_ending";
}

# Delete if exists a previous filesize information file.
if (-e "$file_lenght") {
	unlink("$file_lenght");
	#carp "Unlinked: $file_lenght";
}

$| = 1;


# See if the user has a homefolder.
# Homefolder should have been created when user was accepted by the admin.
# This usually blocks also users below access level 3.
#if (-e $userbasedir) {
#	goodbye("Thank you for trying to use home which you do not posses.<br />Basedir = $userbasedir");
#}

# See if the total upload size is above allowed.
if($totaldata > $maxupload) {
	goodbye("The maximum upload size has been exceeded. Please consider uploading file by file.");
}



# Open the connection to the database.
# This is for logging purposes only.
my $sqlink = DBI->connect(
	# dbi:DriverName:database_name@hostname:port
	'dbi:'.$db_type.':'.$db_name.'@'.$db_host.':'.$db_port, 
	$db_user, 
	$db_pass,
	{ 	
		RaiseError => 1, 
		AutoCommit => 1 
	}
);
#$DBI::errstr



# Insert the information of this upload to the database.
# - user (username of the uploader)
# - whens (unix timestamp when upload was started)
# - whene (unix timestamp when ended if success)
# - totalsize (total size of the data to be uploaded in MegaBytes, rounded)
# - seid (id of the current session)
# Remember size and current time, insert a new row to the database.
my $megabytes = $totaldata / (1024 * 1024);
my $starttime = time();
$sqlink->do("INSERT INTO tu_uploads (user, whens, whene, totalsize, seid) VALUES ('".$username."', '".$starttime."', 0, '".$megabytes."', '".$seid."')");


# Create the file which has the size of the total upload in bytes.
sysopen(FH, $file_lenght, O_RDWR | O_CREAT)
	or &goodbye("Cannot open file for writing length information<br />$!");


#carp "Monitor file should now have been opened/created: $file_lenght";


my $ofh = select(FH); 
$| = 1; 
select ($ofh);

flock(FH, LOCK_EX)
	or &goodbye("Cannot write-lock numfile: $!");
seek(FH, 0, 0)
	or &goodbye("Cannot rewind numfile : $!");
print FH $totaldata;
close(FH);


# Pause for a second so the monitor file is definetly written to it's
# destination.
sleep(0.5);

# Start saving the incoming data to a temporary file.
open(TMP, ">", "$file_data")
	or &goodbye("Cannot open post_data_file for writing temporary data.<br />Name would be: $file_data");

#carp "Post datafile should now have been created: $file_data";

my $i = 0;
$ofh = select(TMP); 
$| = 1; 
select ($ofh);
			
while (read(STDIN, my $LINE, 4096) && $bytesread < $totaldata ) {
	$bytesread += length $LINE;
	$i++;
	print TMP $LINE;
	#carp "TMP line have been written. i: $i";
}
close (TMP);


$| = 1;

# After everything is received, start chopping the data in to peaces and save them 
# to the destination.
open(STDIN, "$file_data") 
	or &goodbye("Cannot open file_data for creating actual posted files.<br />Name would be: $file_data");

#carp "Post datafile should now have been opened for standard input";

my $doggy = new CGI();

my %vars = $doggy->Vars;

while ((my $key, my $value) = each %vars) {
 	#$file_upload = $doggy->param($key);
	if (defined $value && $value ne '') {	
		# Get the original filename.
		my $fh = $doggy->upload($key);
				
		if (defined $fh) {
			my $filename = $fh;
			# Remove all the extra and clean the name of illegal characters.
			$filename =~ s/^.*(\\|\/)//;
			$filename =~ s/ +/\_/g;
			$filename =~ s/\"//g;
			$filename =~ s/ä/a/g;
			$filename =~ s/ö/o/g;
			$filename =~ s/€/e/g;
			$filename =~ s/\"//g;
			$filename =~ s/\'//g;
			#carp $fh, $filename;
			
			# Create the destination file and write data in to it.

			#carp "Starting to write in destination: $userbasedir / $filename";
			
			open(HAYA, ">", $userbasedir."/".$filename);
			while(<$fh>) {
				print HAYA $_;
			}
			close(HAYA);
		}
	}
}

# Now it is time to update the database since it seems that the upload was successful.
my $endtime = time();
$sqlink->do("UPDATE tu_uploads SET ended='".$endtime."' WHERE user='".$username."' AND started='".$starttime."' LIMIT 1");
  
# Close the connection to the database.
$sqlink->disconnect;

# Remember to clean up those files which are no longer needed.
unlink("$file_lenght");
unlink("$file_data");

# Inform the periscope that the upload is done.
open(SIGNAL, ">", $file_ending);
print SIGNAL "\n";
close(SIGNAL);

# Go there where no man has gone before.
print "Location: $whereafter\n\n";
